Package: CoSIA
Type: Package
Title: An Investigation Across Different Species and Tissues
Version: 1.13.1
Authors@R: 
  c(person(given = "Anisha",
           family = "Haldar",
           role = "aut",
           comment = c(ORCID = "0000-0002-1395-9793")),
    person(given = c("Vishal", "H."),
           family = "Oza",
           role = "aut",
           comment = c(ORCID = "0000-0001-6990-0267")),
    person(given = c("Amanda", "D."),
           family = "Clark",
           role = c("aut"),
           email = "clarkaduab@gmail.com",
           comment = c(ORCID = "0000-0002-1186-3114")),
    person(given = c("Anthony", "B."),
           family = "Crumley",
           role = c("cre", "aut"),
           email = "acrumley@uab.edu",
           comment = c(ORCID = "0009-0004-7347-4722")),
    person(given = c("Nathaniel", "S."),
           family = "DeVoss",
           role = "aut",
           comment = c(ORCID = "0000-0003-0465-2770")),
    person(given = c("Brittany", "N."),
           family = "Lasseigne",
           role = c("aut"),
           comment = c(ORCID = "0000-0002-1642-8904")))
Description: 
  Cross-Species Investigation and Analysis (CoSIA) is a package that provides
  researchers with an alternative methodology for comparing across species and
  tissues using normal wild-type RNA-Seq Gene Expression data from Bgee. Using
  RNA-Seq Gene Expression data, CoSIA provides multiple visualization tools to
  explore the transcriptome diversity and variation across genes, tissues, and
  species. CoSIA uses the Coefficient of Variation and Shannon Entropy and
  Specificity to calculate transcriptome diversity and variation. CoSIA also
  provides additional conversion tools and utilities to provide a streamlined
  methodology for cross-species comparison.
License: MIT + file LICENSE
Encoding: UTF-8
Depends: R (>= 4.3.0), methods (>= 4.3.0), ExperimentHub (>= 2.7.0)
Imports: dplyr (>= 1.0.7), magrittr (>= 2.0.1), RColorBrewer (>=
        1.1-2), tidyr (>= 1.2.0), plotly (>= 4.10.0), stringr (>=
        1.4.0), ggplot2 (>= 3.3.5), tibble (>= 3.1.7), org.Hs.eg.db (>=
        3.12.0), org.Mm.eg.db (>= 3.12.0), org.Dr.eg.db (>= 3.12.0),
        org.Ce.eg.db (>= 3.12.0), org.Dm.eg.db (>= 3.12.0),
        org.Rn.eg.db (>= 3.12.0), AnnotationDbi (>= 1.52.0), biomaRt
        (>= 2.46.3), homologene (>= 1.4.68.19), annotationTools (>=
        1.64.0), readr (>= 2.1.1), tidyselect (>= 1.1.2), stats (>=
        4.1.2)
RoxygenNote: 7.3.3
Suggests: BiocStyle (>= 2.22.0), tidyverse (>= 1.3.1), knitr (>= 1.42),
        rmarkdown (>= 2.20), testthat (>= 3.1.6), qpdf (>= 1.3.0)
biocViews: Software, BiologicalQuestion, GeneExpression,
        MultipleComparison, ThirdPartyClient, DataImport, GUI
BugReports: https://github.com/lasseignelab/CoSIA/issues
URL: https://www.lasseigne.org/
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/CoSIA
git_branch: devel
git_last_commit: 090a204
git_last_commit_date: 2026-05-27
Repository: Bioconductor 3.24
Date/Publication: 2026-06-01
NeedsCompilation: no
Packaged: 2026-06-01 22:04:19 UTC; biocbuild
Author: Anisha Haldar [aut] (ORCID: <https://orcid.org/0000-0002-1395-9793>),
  Vishal H. Oza [aut] (ORCID: <https://orcid.org/0000-0001-6990-0267>),
  Amanda D. Clark [aut] (ORCID: <https://orcid.org/0000-0002-1186-3114>),
  Anthony B. Crumley [cre, aut] (ORCID:
    <https://orcid.org/0009-0004-7347-4722>),
  Nathaniel S. DeVoss [aut] (ORCID:
    <https://orcid.org/0000-0003-0465-2770>),
  Brittany N. Lasseigne [aut] (ORCID:
    <https://orcid.org/0000-0002-1642-8904>)
Maintainer: Anthony B. Crumley <acrumley@uab.edu>

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.7674870.svg)](https://doi.org/10.5281/zenodo.7674870)

# CoSIA: **C**r**o**ss **S**pecies **I**nvestigation and **A**nalysis

**C**r**o**ss **S**pecies **I**nvestigation and **A**nalysis (`CoSIA`) is a package that provides researchers with an alternative methodology for comparing across species and tissues using normal wild-type RNA-Seq Gene Expression data from Bgee. Using RNA-Seq Gene Expression data, CoSIA provides multiple visualization tools to explore the transcriptome diversity and variation across genes, tissues, and species. CoSIA uses Coefficient of Variation and Shannon Entropy and Specificity to calculate transcriptome diversity and variation. CoSIA also provides additional conversion tools and utilities to provide a streamlined methodology for cross-species comparison across the tissues and genes of five commonly used biomedical research species (*Mus musculus*, *Rattus norvegicus*, *Danio rerio*, *Drosophila melanogaster*, and *Caenorhabditis elegans*) in addition to *Homo sapiens*.

<img src="inst/images/CoSIA_Workflow.png" alt="Figure 1. CoSIA_Workflow" width="703"/>

CoSIA is split into 3 methods that provide various resources in order for researchers to conduct cross species analysis using gene expression metrics.

The first method `getConversion` is used to conduct gene identifier and ortholog conversions.

The second method `getGEx` is used to obtain the raw gene expression values (Variance Stabilizing Transformation of Read Counts) of a gene or set of gene among tissues or species of choice. The data obtained in `getGEx` can then be visualized for a single gene *across multiple tissues in single model organism* through `plotTissueGEx` or *across multiple species in a single tissue* through `plotSpeciesGEx`.

The third method `getGExMetrics` provides various methodologies in calculating median-based Coefficient of Variation (variability) and Shannon Entropy (diversity & specificity). Once calculated, `plotCVGEx` & `plotDSGEx` can be used to visualize the variation and diversity & specificity (DS) of gene expression across genes, tissues, and species.

## Getting Started

### Installing

In R:

``` {r eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("CoSIA")
library(CoSIA)
```

### Using CoSIA

Check out the vignette for more information on how to use CoSIA and its 
functionality.

## Authors

-   Anisha Haldar
-   Vishal H. Oza
-   Nathaniel DeVoss
-   Amanda D. Clark
-   Brittany N. Lasseigne

## Lasseigne Lab

[What is Happening in the Lasseigne Lab?](https://www.lasseigne.org/)

<img src="https://www.lasseigne.org/img/main/lablogo.png" width="75" height="75">

## Funding

This work was supported in part by the UAB Lasseigne Lab Start-Up funds (BNL, 
AH, ND, ADC and VHO), the UAB Pilot Center for Precision Animal Modeling (C-PAM)
(1U54OD030167) (BNL and VHO), UAB Pilot Center for Precision Animal Modeling 
(C-PAM) - Diversity Supplement (3U54OD030167-03S1) (ADC), and Mentored 
Experiences in Research, Instruction, and Teaching (MERIT) Program 
(K12 GM088010) (ADC).

## Acknowledgements

The authors would like to thank the members of the Lassigne lab for their 
support and feedback, in particular, Elizabeth J. Wilk, Jordan Whitlock, 
and Timothy C. Howton.

## License

This project is licensed under the MIT License - 
see the [LICENSE.md](LICENSE.md) file for details

#Global Variables
utils::globalVariables(c("Anatomical_entity_name", "Anatomical_entity_ID", 
                         "Species", "Frequency", "Ensembl_ID","VST",".",
                         "Scaled_Median_VST", "mad", "Specificity",
                         "Diversity", "is"))

#' getGEx Generic
#'
#' @param object CoSIAn object with all user accessible slots filled with
#' converted_id slot filled
#' @return initializes a generic function for getGEx as preparation for
#' defining the getGEx Method
#' @export
#' @import ExperimentHub
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c("r_norvegicus"), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
setGeneric("getGEx", function(object) standardGeneric("getGEx"))
# CoSIAn getGEx
################################################################################
#' getGEx Method
#' @method get GEx
#' @param object CoSIAn object with all user accessible slots filled with
#' converted_id slot filled
#' @return CoSIAn Object with gex slot filled
#' @export
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c("r_norvegicus"), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
setMethod("getGEx", signature(object = "CoSIAn"), function(object) {
    # add validity that converted_id is filled in
    # set needed slots to variables in the
    id_dataframe <- object@converted_id
    id_dataframe <- as.data.frame(id_dataframe)
    map_species <- object@map_species
    map_tissues <- object@map_tissues
    Species_SWITCH <- Vectorize(
        vectorize.args = "map_species",
        FUN = function(map_species) {
            switch(as.character(map_species),
                h_sapiens = "h_sapiens_ensembl_id",
                m_musculus = "m_musculus_ensembl_id",
                r_norvegicus = "r_norvegicus_ensembl_id",
                d_rerio = "d_rerio_ensembl_id",
                d_melanogaster = "d_melanogaster_ensembl_id",
                c_elegans = "c_elegans_ensembl_id",
                stop("Invalid map_species in CoSIAn Object.
               Make sure the species in the map_species slot are an avalible
               model organism and are in the correct format.")
            )
        }
    )
    map_species <- Species_SWITCH(map_species)
    id_dataframe <- dplyr::select(
        id_dataframe,
        tidyselect::matches(map_species)
    )
    eh <- ExperimentHub::ExperimentHub()
    return_filtered_Gex_data <- function(map_species) {
        GEx_data <- data.frame(matrix(ncol = 9, nrow = 0))
        colnames(GEx_data) <- c(
            "Anatomical_entity_name", "Ensembl_ID",
            "Sample_size", "VST", "Experiment_ID",
            "Anatomical_entity_ID", "Species",
            "Scaled_Median_VST", "mad"
        )
        if (any(map_species == "m_musculus_ensembl_id")) {
            mm_EH_File <- eh[["EH7859"]][[1]]
            m_ensembl_id <- id_dataframe$m_musculus
            gene_specific_data <- dplyr::filter(
                mm_EH_File,
                Ensembl_ID %in% m_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else if (any(map_species == "r_norvegicus_ensembl_id")) {
            rn_EH_File <- eh[["EH7860"]][[1]]
            r_ensembl_id <- id_dataframe$r_norvegicus
            gene_specific_data <- dplyr::filter(
                rn_EH_File,
                Ensembl_ID %in% r_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else if (any(map_species == "d_rerio_ensembl_id")) {
            dr_EH_File <- eh[["EH7861"]][[1]]
            dr_ensembl_id <- id_dataframe$d_rerio
            gene_specific_data <- dplyr::filter(
                dr_EH_File,
                Ensembl_ID %in% dr_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else if (any(map_species == "h_sapiens_ensembl_id")) {
            hs_EH_File <- eh[["EH7858"]][[1]]
            hs_ensembl_id <- id_dataframe$h_sapiens
            gene_specific_data <- dplyr::filter(
                hs_EH_File,
                Ensembl_ID %in% hs_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else if (any(map_species == "c_elegans_ensembl_id")) {
            ce_EH_File <- eh[["EH7863"]][[1]]
            c_ensembl_id <- id_dataframe$c_elegans
            gene_specific_data <- dplyr::filter(
                ce_EH_File,
                Ensembl_ID %in% c_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else if (any(map_species == "d_melanogaster_ensembl_id")) {
            dm_EH_File <- eh[["EH7862"]][[1]]
            dm_ensembl_id <- id_dataframe$d_melanogaster
            gene_specific_data <- dplyr::filter(
                dm_EH_File,
                Ensembl_ID %in% dm_ensembl_id
            )
            GEx_data <- rbind(GEx_data, gene_specific_data)
            GEx_data <- as.data.frame(GEx_data)
        } else {
            stop("map_species in CoSIAn Object.
            Make sure the species in the map_species slot are avalible model
            organisms and are in the correct format.")
        }
        return(GEx_data)
    }
    GEx_data <- lapply(map_species, return_filtered_Gex_data)
    GEx_data <- dplyr::bind_rows(GEx_data)
    GEx_data <- dplyr::filter(GEx_data, Anatomical_entity_name %in% map_tissues)
    rownames(GEx_data) <- NULL
    object@gex <- data.frame(GEx_data)
    return(object)
})

#' plotSpeciesGEx Generic
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and gex slot filled
#' @param single_tissue one tissue that the user wants to investigate across the
#'  mapped species
#' @param single_gene one ensembl id that the user wants to investigate across
#' the mapped species
#' @return initializes a generic function for plotSpeciesGEx as preparation for
#' defining the plotSpeciesGEx Method
#'
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'     "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
#' plotSpeciesGEx(Kidney_gene_gex, "liver", "ENSG00000008710")
setGeneric(
    "plotSpeciesGEx",
    function(object,
             single_tissue,
             single_gene) {
        standardGeneric("plotSpeciesGEx")
    }
)

#' plotSpeciesGEx Method
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and gex slot filled
#' @param single_tissue one tissue that the user wants to investigate across the
#'  mapped species
#' @param single_gene one ensembl id that the user wants to investigate across
#' the mapped species
#'
#' @return plot object
#' @export
#' @importFrom tidyselect ends_with
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "d_melanogaster", "d_rerio", "c_elegans", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
#' plotSpeciesGEx(Kidney_gene_gex, "liver", "ENSG00000008710")
setMethod(
    "plotSpeciesGEx", signature(object = "CoSIAn"),
    function(object, single_tissue, single_gene) {
        gex_dataframe <- object@gex
        gex_dataframe <- as.data.frame(gex_dataframe)
        converted_id <- object@converted_id
        converted_id <- as.data.frame(converted_id)
        filter_ids <- dplyr::select(converted_id, ends_with("ensembl_id"))
        ids <- filter_ids[Reduce(`|`, lapply(filter_ids, grepl,
            pattern = single_gene
        )), ]
        ids <- as.character(ids)
        filter_gex <- gex_dataframe[gex_dataframe$Ensembl_ID %in% ids, ]
        filter_gex <- filter_gex[
            filter_gex$Anatomical_entity_name %in% single_tissue,
        ]
        filter_gex <- tidyr::separate_rows(filter_gex, VST)
        filter_gex$VST <- as.numeric(filter_gex$VST)
        filter_gex <- as.data.frame(filter_gex)
        brewer.pal.info <- RColorBrewer::brewer.pal.info
        palette5 <- RColorBrewer::brewer.pal.info[
            brewer.pal.info$category == "qual",
        ]
        color <- unlist(mapply(
            RColorBrewer::brewer.pal,
            palette5$maxcolors, rownames(palette5)
        ))
        fig <- filter_gex %>%
            plotly::plot_ly(
                x = ~Species, y = ~VST, type = "scatter",
                mode = "markers", color = ~Species, colors = color
            )
        fig <- fig %>%
            plotly::add_trace(
                marker = list(
                    size = 8,
                    line = list(color = "black", width = 0.75)
                ),
                showlegend = FALSE
            )

        fig <- fig %>%
            plotly::add_trace(
                type = "violin",
                spanmode = "hard",
                showlegend = FALSE
            )
        fig <- fig %>%
            plotly::layout(
                xaxis = list(title = "Species", size = 2),
                yaxis = list(
                    title =
                        "VST of Read Counts",
                    zeroline = FALSE
                ), title = stringr::str_wrap(paste("Gene Expression
                                                   of the gene",
                    single_gene, "in", single_tissue,
                    "across species",
                    sep = " "
                )), showlegend = FALSE
            )
        return(fig)
    }
)

#' plotTissueGEx Generic
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and gex slot filled
#' @param single_species one species that the user wants to investigate across
#' the mapped tissues
#' @param single_gene one ensembl id that the user wants to investigate across
#' the mapped tissues
#' @return initializes a generic function for plotTissueGEx as preparation for
#' defining the plotTissueGEx Method
#'
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "d_melanogaster", "d_rerio", "c_elegans", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart",
#'     map_species = c("r_norvegicus"), metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
#' plotTissueGEx(Kidney_gene_gex, "m_musculus", "ENSG00000008710")
setGeneric("plotTissueGEx", function(object, single_species, single_gene) {
    standardGeneric("plotTissueGEx")
})

#' plotTissueGEx Method
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and gex slot filled
#' @param single_species one species that the user wants to investigate across
#' the mapped tissues
#' @param single_gene one ensembl id that the user wants to investigate across
#' the mapped tissues
#'
#' @return plot object
#' @export
#' @importFrom tidyselect ends_with

#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "d_melanogaster", "d_rerio", "c_elegans", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
#' plotTissueGEx(Kidney_gene_gex, "m_musculus", "ENSG00000008710")
setMethod(
    "plotTissueGEx", signature(object = "CoSIAn"),
    function(object, single_species, single_gene) {
        gex_dataframe <- object@gex
        gex_dataframe <- as.data.frame(gex_dataframe)
        converted_id <- object@converted_id
        converted_id <- as.data.frame(converted_id)
        Species_SWITCH <- Vectorize(
            vectorize.args = "single_species",
            FUN = function(single_species) {
                switch(as.character(single_species),
                    h_sapiens = "Homo_sapiens",
                    m_musculus = "Mus_musculus",
                    r_norvegicus = "Rattus_norvegicus",
                    d_rerio = "Danio_rerio",
                    d_melanogaster = "Drosophila_melanogaster",
                    c_elegans = "Caenorhabditis_elegans",
                    stop("Invalid map_species in CoSIAn Object.
            Make sure the species in the map_species slot are an avalible model
            organism and are in the correct format.")
                )
            }
        )

        single_species <- Species_SWITCH(single_species)
        filter_ids <- dplyr::select(converted_id, ends_with("ensembl_id"))
        ids <- filter_ids[Reduce(`|`, lapply(filter_ids,
            grepl,
            pattern = single_gene
        )), ]
        ids <- as.character(ids)
        filter_gex <- gex_dataframe[gex_dataframe$Ensembl_ID %in% ids, ]
        filter_gex <- filter_gex[filter_gex$Species %in% single_species, ]
        filter_gex <- tidyr::separate_rows(filter_gex, VST)
        filter_gex$VST <- as.numeric(filter_gex$VST)

        brewer.pal.info <- RColorBrewer::brewer.pal.info
        palette5 <- RColorBrewer::brewer.pal.info[
            brewer.pal.info$category == "qual",
        ]
        color <- unlist(mapply(
            RColorBrewer::brewer.pal,
            palette5$maxcolors, rownames(palette5)
        ))
        fig <- filter_gex %>%
            plotly::plot_ly(
                x = ~Anatomical_entity_name, y = ~VST, type = "scatter",
                mode = "markers", color = ~Anatomical_entity_name,
                colors = color
            )

        fig <- fig %>%
            plotly::add_trace(
                marker = list(
                    size = 8,
                    line = list(color = "black", width = 0.75)
                ),
                showlegend = FALSE
            )

        fig <- fig %>%
            plotly::add_trace(
                type = "violin",
                spanmode = "hard",
                showlegend = FALSE
            )
        fig <- fig %>%
            plotly::layout(
                xaxis = list(title = "Anatomical Entity Name", size = 2),
                yaxis = list(
                    title = "VST of Read Counts",
                    zeroline = FALSE
                ), title = stringr::str_wrap(paste("Gene Expression of the
                                                   gene",
                    single_gene, "in", single_species,
                    "across tissues",
                    sep = " "
                )), showlegend = FALSE
            )

        return(fig)
    }
)


#' plotDSGEx Generic
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and metric slot filled
#' @return initializes a generic function for plotDSGEx as preparation for
#' defining the plotDSGEx Method
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'     "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
#' plotDSGEx(Kidney_gene_metric)
setGeneric("plotDSGEx", function(object) standardGeneric("plotDSGEx"))


#' plotDSGEx Method
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and metric slot filled
#'
#' @return plot object
#' @export
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'     "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
#' plotDSGEx(Kidney_gene_metric)
setMethod("plotDSGEx", signature(object = "CoSIAn"), function(object) {
    metric_type <- object@metric_type
    df_metric <- object@metric
    if (metric_type == "DS_Gene") {
        cols <- c(
            "#88CCEE", "#CC6677", "#DDCC77", "#332288", "#AA4499", "#44AA99",
            "#999933", "#882255", "#661100", "#117733",
            "#6699CC", "#888888"
        ) # make these colors color blind friendly
        DS_plot <- ggplot2::ggplot(df_metric, ggplot2::aes(
            x = Specificity,
            y = Diversity, color = Species
        ))
        DS_plot <- DS_plot + ggplot2::geom_point(
            size = 3,
            ggplot2::aes()
        ) + ggplot2::scale_color_manual(values = cols) +
            ggplot2::ggtitle("Diversity versus Specificity of Genes in Geneset
                           \nAcross Mapped Tissues in a Species") +
            ggplot2::theme_classic()
    } else if (metric_type == "DS_Tissue") {
        cols <- c(
            "#88CCEE", "#CC6677", "#DDCC77", "#332288", "#AA4499", "#44AA99",
            "#999933", "#117733", "#882255", "#661100",
            "#6699CC", "#888888"
        ) # make these colors color blind friendly
        DS_plot <- ggplot2::ggplot(df_metric, ggplot2::aes(
            x = Specificity,
            y = Diversity, color = Anatomical_entity_name
        ))
        DS_plot <- DS_plot + ggplot2::geom_point(
            size = 3,
            ggplot2::aes(shape = Species)
        ) +
            ggplot2::scale_color_manual(values = cols) +
            ggplot2::ggtitle("Diversity versus Specificity of Genes in Geneset
                             \nAcross Anatomical Entity Names") +
            ggplot2::theme_classic()
    } else if (metric_type == "DS_Tissue_all") {
        cols <- c(
            "#88CCEE", "#CC6677", "#DDCC77", "#332288", "#AA4499", "#44AA99",
            "#999933", "#117733", "#882255", "#661100",
            "#6699CC", "#888888"
        ) # make these colors color blind friendly
        DS_plot <- ggplot2::ggplot(df_metric, ggplot2::aes(
            x = Specificity,
            y = Diversity, color = Anatomical_entity_name
        ))
        DS_plot <- DS_plot + ggplot2::geom_point(
            size = 3,
            ggplot2::aes(shape = Species)
        ) + ggplot2::scale_color_manual(values = cols) +
            ggplot2::ggtitle("Diversity versus Specificity of All Genes \nAcross
                             Anatomical Entity Names") +
            ggplot2::theme_classic()
    } else if (metric_type == "DS_Gene_all") {
        cols <- c(
            "#88CCEE", "#CC6677", "#DDCC77", "#332288", "#AA4499", "#44AA99",
            "#999933", "#882255", "#661100", "#117733",
            "#6699CC", "#888888"
        ) # make these colors color blind friendly
        DS_plot <- ggplot2::ggplot(df_metric, ggplot2::aes(
            x = Specificity,
            y = Diversity, color = Species
        ))
        DS_plot <- DS_plot + ggplot2::geom_point(
            size = 3,
            ggplot2::aes()
        ) + ggplot2::scale_color_manual(values = cols) +
            ggplot2::ggtitle("Diversity versus Specificity of Genes in Geneset
            \nAcross all Tissues in a Species") +
            ggplot2::theme_classic()
    } else {
        stop("Invalid metric type for plotDS make sure you have a DS
             argument as the metric type and the values are saved in the metric
             slot before proceeding. ")
    }
    return(DS_plot)
})

#' plotCVGEx Generic
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and metric slot filled
#'
#' @return initializes a generic function for plotCVGEx as preparation for
#' defining the plotCVGEx Method
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "h_sapiens", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = c("adult mammalian kidney","heart"), 
#'     map_species = c("h_sapiens", "r_norvegicus"),
#'     metric_type = "CV_Tissue"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
#' plot <- plotCVGEx(Kidney_gene_metric)
setGeneric("plotCVGEx", function(object) standardGeneric("plotCVGEx"))


#' plotCVGEx Method
#'
#' @param object CoSIAn object with all user accessible slots filled in as well
#' as the converted_id and metric slot filled
#'
#' @return plot object
#' @export
#' @importFrom tibble remove_rownames
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "h_sapiens", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = c("adult mammalian kidney","heart"), 
#'     map_species = c("h_sapiens", "r_norvegicus"),
#'     metric_type = "CV_Tissue"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
#' plot <- plotCVGEx(Kidney_gene_metric)
#' @references Dot plot in R with the dotchart function [with examples]. 
#' R CODER. (2020, November 20). Retrieved from https://r-coder.com/dot-plot-r/ 
setMethod("plotCVGEx", signature(object = "CoSIAn"), function(object) {
    # set object slots into variables
    metric_type <- object@metric_type
    df_metric <- object@metric

    # Dumbbell Plot Function Plot:
    # Adapted from R CODER
    dumbbell <- function(df, segments = TRUE, text = FALSE, pch = 19,
                         pt.cex = 1, segcol = 1, lwd = 1,
                         main = "", metric = "",
                         ...) {
        n_col <- ncol(df) - 1
        n_row <- nrow(df)
        df_subset <- df[, -1]
        group <- rep(1, n_row)

        o <- sort.list(as.numeric(group), decreasing = TRUE)
        group <- group[o]
        offset <- cumsum(c(0, diff(as.numeric(group)) != 0))
        y <- 1L:n_row + 2 * offset

        graphics::dotchart(df[, 2],
            labels = df$ensembl_id, color = 1, xlim = range(0, 1) + c(0, 0.1),
            groups = group, pch = NA,
            pt.cex = pt.cex, main = main,
            xlab = "Coefficient of Variation (CV)",
            ylab = col1
        )

        if (segments == TRUE) {
            for (i in seq_len(n_row)) {
                segments(min(df_subset[i, ]), y[i], max(df_subset[i, ]),
                    y[i],
                    lwd = lwd, col = segcol
                )
            }
        }
        if (metric == "CV_Tissue") {
            col <- c("plum", "tomato", "paleturquoise", "lightcoral")
            pch <- c(19, 18, 17, 16, 15, 3, 4, 8, 7, 9, 10, 13)
            count <- 1
            for (i in seq_len(n_row)) {
                if (count / length(map_tissues) == 1) {
                    count <- 1
                } else {
                    count <- count + 1
                }
                for (j in seq_len(n_col)) {
                    graphics::points(df_subset[i, j], y[i],
                        pch = pch[count],
                        cex = pt.cex, col = col[j]
                    )
                }
            }
        }
        if (metric == "CV_Species") {
            col <- c("plum", "tomato", "paleturquoise", "lightcoral")
            for (i in seq_len(n_row)) {
                for (j in seq_len(n_col)) {
                    graphics::points(df_subset[i, j], y[i],
                        pch = 19,
                        cex = pt.cex, col = col[j]
                    )
                }
            }
        }

        graphics::legend("topright",
            legend = colnames(df_subset), col = col, pch = 19, bty = "n",
            pt.cex = 1, cex = 1, text.col = "black",
            horiz = FALSE, inset = c(0, 0)
        )
    }

    if (metric_type == "CV_Species") {
        # CV Species
        input_species <- object@i_species
        col1 <- paste(input_species, "ensembl_id", sep = "_")
        CV_Species_Plot <- df_metric %>%
            remove_rownames() %>%
            column_to_rownames(var = col1)
        CV_Species_Plot <- dplyr::select(
            CV_Species_Plot,
            contains("CV_species")
        )
        CV_Species_Plot <- tibble::rownames_to_column(
            CV_Species_Plot,
            "ensembl_id"
        )
        colnames(CV_Species_Plot) <- gsub(
            "_CV_species", "",
            colnames(CV_Species_Plot)
        )
        CV_plot <- dumbbell(CV_Species_Plot,
            text = FALSE, segments = TRUE, pt.cex = 1,
            main = "CV across Species in Geneset",
            metric = "CV_Species"
        )
    } else if (metric_type == "CV_Tissue") {
        map_tissues <- object@map_tissues
        input_species <- object@i_species
        col1 <- paste(input_species, "ensembl_id", sep = "_")
        CV_Tissue_Plot <- df_metric %>%
            tidyr::unite("ensembl_id_AE_names",
                tidyselect::all_of(col1),
                Anatomical_entity_name,
                sep = "_", remove = FALSE
            )
        CV_Tissue_Plot <- CV_Tissue_Plot %>%
            remove_rownames() %>%
            column_to_rownames(var = "ensembl_id_AE_names")
        CV_Tissue_Plot <- dplyr::select(CV_Tissue_Plot, contains("CV_tissue"))
        CV_Tissue_Plot <- tibble::rownames_to_column(
            CV_Tissue_Plot,
            "ensembl_id_AE_names"
        )
        colnames(CV_Tissue_Plot) <- gsub(
            "_CV_tissue", "",
            colnames(CV_Tissue_Plot)
        )
        CV_Tissue_Plot <- CV_Tissue_Plot[with(
            CV_Tissue_Plot,
            order(ensembl_id_AE_names)
        ), ]
        CV_plot <- dumbbell(CV_Tissue_Plot,
            text = FALSE, segments = TRUE, pt.cex = 1,
            main = "CV across Tissues in Geneset",
            metric = "CV_Tissue", map_tissues = map_tissues
        )
    } else {
        stop("Invalid metric type for plotCV make sure you have a CV
             argument as the metric type and the values are saved in the metric
             slot before proceeding. ")
    }
    return(CV_plot)
})

# Shared fixtures for CoSIA tests

.minimal_args <- list(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens",
    input_id = "Ensembl_id",
    o_species = c("h_sapiens", "m_musculus"),
    output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene",
    map_tissues = "heart",
    map_species = "m_musculus",
    metric_type = "DS_Gene"
)

# Build a CoSIAn with any slot overridden
make_cosian <- function(...) {
    args <- utils::modifyList(.minimal_args, list(...))
    do.call(CoSIAn, args)
}

# Skip if ExperimentHub is not reachable
skip_if_no_experimenthub <- function() {
    skip_if_offline()
    tryCatch(
        ExperimentHub::ExperimentHub(),
        error = function(e) skip(paste("ExperimentHub unavailable:", conditionMessage(e)))
    )
}

test_that("CoSIAn constructor returns a CoSIAn object", {
    obj <- make_cosian()
    expect_s4_class(obj, "CoSIAn")
})

test_that("constructor initializes input slots correctly", {
    obj <- make_cosian()
    expect_identical(obj@gene_set, .minimal_args$gene_set)
    expect_identical(obj@i_species, "h_sapiens")
    expect_identical(obj@input_id, "Ensembl_id")
    expect_identical(obj@o_species, c("h_sapiens", "m_musculus"))
    expect_identical(obj@output_ids, c("Ensembl_id", "Symbol"))
    expect_identical(obj@mapping_tool, "annotationDBI")
    expect_identical(obj@ortholog_database, "HomoloGene")
    expect_identical(obj@map_tissues, "heart")
    expect_identical(obj@map_species, "m_musculus")
    expect_identical(obj@metric_type, "DS_Gene")
})

test_that("constructor initializes output slots as empty data frames", {
    obj <- make_cosian()
    expect_s3_class(obj@converted_id, "data.frame")
    expect_s3_class(obj@gex, "data.frame")
    expect_s3_class(obj@metric, "data.frame")
})

test_that("mapping_tool defaults to annotationDBI", {
    obj <- CoSIAn(
        gene_set = .minimal_args$gene_set,
        i_species = "h_sapiens",
        input_id = "Ensembl_id",
        o_species = "h_sapiens",
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "h_sapiens",
        metric_type = "DS_Gene"
    )
    expect_identical(obj@mapping_tool, "annotationDBI")
})

test_that("ortholog_database defaults to HomoloGene", {
    obj <- CoSIAn(
        gene_set = .minimal_args$gene_set,
        i_species = "h_sapiens",
        input_id = "Ensembl_id",
        o_species = "h_sapiens",
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "h_sapiens",
        metric_type = "DS_Gene"
    )
    expect_identical(obj@ortholog_database, "HomoloGene")
})

test_that("constructor errors on missing i_species", {
    expect_error(
        make_cosian(i_species = character(0)),
        regexp = "i_species"
    )
})

test_that("constructor errors when i_species has length > 1", {
    expect_error(
        make_cosian(i_species = c("h_sapiens", "m_musculus")),
        regexp = "i_species"
    )
})

test_that("constructor errors on missing input_id", {
    expect_error(
        make_cosian(input_id = character(0)),
        regexp = "input_id"
    )
})

test_that("constructor errors when input_id has length > 1", {
    expect_error(
        make_cosian(input_id = c("Ensembl_id", "Symbol")),
        regexp = "input_id"
    )
})

test_that("constructor errors when mapping_tool has length > 1", {
    expect_error(
        make_cosian(mapping_tool = c("annotationDBI", "biomaRt")),
        regexp = "mapping_tool"
    )
})

test_that("constructor errors when ortholog_database has length > 1", {
    expect_error(
        make_cosian(ortholog_database = c("HomoloGene", "NCBIOrtho")),
        regexp = "ortholog_database"
    )
})

test_that("constructor errors on empty gene_set", {
    expect_error(
        make_cosian(gene_set = character(0)),
        regexp = "gene_set"
    )
})

# getGEx fetches data from ExperimentHub and requires network on first run.
# After the initial download, ExperimentHub caches locally.

test_that("getGEx returns a CoSIAn object", {
    skip_if_no_experimenthub()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "m_musculus"
    )
    obj <- getConversion(obj)
    result <- getGEx(obj)
    expect_s4_class(result, "CoSIAn")
})

test_that("getGEx populates the gex slot", {
    skip_if_no_experimenthub()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "m_musculus"
    )
    obj <- getConversion(obj)
    result <- getGEx(obj)
    expect_s3_class(result@gex, "data.frame")
    expect_gt(nrow(result@gex), 0)
})

test_that("getGEx gex slot has expected columns", {
    skip_if_no_experimenthub()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "m_musculus"
    )
    obj <- getConversion(obj)
    result <- getGEx(obj)
    expected_cols <- c(
        "Anatomical_entity_name", "Ensembl_ID", "Sample_size",
        "VST", "Experiment_ID", "Anatomical_entity_ID", "Species"
    )
    expect_true(all(expected_cols %in% colnames(result@gex)))
})

test_that("getGEx filters results to requested tissues", {
    skip_if_no_experimenthub()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "m_musculus"
    )
    obj <- getConversion(obj)
    result <- getGEx(obj)
    expect_true(all(result@gex$Anatomical_entity_name == "heart"))
})

test_that("getGEx filters results to requested species", {
    skip_if_no_experimenthub()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = "heart",
        map_species = "m_musculus"
    )
    obj <- getConversion(obj)
    result <- getGEx(obj)
    expect_true(all(result@gex$Species == "Mus_musculus"))
})

# getGExMetrics requires ExperimentHub data; tests skip when offline.
# Helper to build a converted CoSIAn object for a given metric type.
make_converted <- function(metric_type, map_tissues = "heart",
                           map_species = "m_musculus") {
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_tissues = map_tissues,
        map_species = map_species,
        metric_type = metric_type
    )
    getConversion(obj)
}

test_that("getGExMetrics returns a CoSIAn object", {
    skip_if_no_experimenthub()
    obj <- make_converted("DS_Gene")
    result <- getGExMetrics(obj)
    expect_s4_class(result, "CoSIAn")
})

test_that("DS_Gene metric slot is a non-empty data frame", {
    skip_if_no_experimenthub()
    obj <- make_converted("DS_Gene")
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_gt(nrow(result@metric), 0)
})

test_that("DS_Gene metric has Ensembl_ID, Specificity, Diversity, Species columns", {
    skip_if_no_experimenthub()
    obj <- make_converted("DS_Gene")
    result <- getGExMetrics(obj)
    expect_true(all(c("Ensembl_ID", "Specificity", "Diversity", "Species") %in%
        colnames(result@metric)))
})

test_that("DS_Tissue metric has Anatomical_entity_name, Specificity, Diversity, Species columns", {
    skip_if_no_experimenthub()
    obj <- make_converted(
        "DS_Tissue",
        map_tissues = c("heart", "liver", "kidney")
    )
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_true(all(c("Anatomical_entity_name", "Specificity", "Diversity", "Species") %in%
        colnames(result@metric)))
})

test_that("DS_Tissue errors with fewer than two genes", {
    skip_if_no_experimenthub()
    obj <- CoSIAn(
        gene_set = "ENSG00000008710",
        i_species = "h_sapiens",
        input_id = "Ensembl_id",
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        mapping_tool = "annotationDBI",
        ortholog_database = "HomoloGene",
        map_tissues = c("heart", "liver"),
        map_species = "m_musculus",
        metric_type = "DS_Tissue"
    )
    obj <- getConversion(obj)
    expect_error(getGExMetrics(obj), regexp = "more than one gene")
})

test_that("DS_Gene_all metric slot is a non-empty data frame", {
    skip_if_no_experimenthub()
    obj <- make_converted("DS_Gene_all")
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_gt(nrow(result@metric), 0)
})

test_that("DS_Tissue_all metric slot is a non-empty data frame", {
    skip_if_no_experimenthub()
    obj <- make_converted(
        "DS_Tissue_all",
        map_tissues = c("heart", "liver", "kidney")
    )
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_gt(nrow(result@metric), 0)
})

test_that("CV_Tissue metric slot is a non-empty data frame", {
    skip_if_no_experimenthub()
    obj <- make_converted("CV_Tissue")
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_gt(nrow(result@metric), 0)
})

test_that("CV_Species metric slot is a non-empty data frame", {
    skip_if_no_experimenthub()
    obj <- make_converted("CV_Species")
    result <- getGExMetrics(obj)
    expect_s3_class(result@metric, "data.frame")
    expect_gt(nrow(result@metric), 0)
})

test_that("getGExMetrics errors on invalid metric_type", {
    skip_if_no_experimenthub()
    obj <- make_converted("DS_Gene")
    obj@metric_type <- "invalid_metric"
    expect_error(getGExMetrics(obj))
})

test_that("viewCoSIAn returns converted_id slot", {
    obj <- make_cosian()
    result <- viewCoSIAn(obj, "converted_id")
    expect_s3_class(result, "data.frame")
})

test_that("viewCoSIAn returns gex slot", {
    obj <- make_cosian()
    result <- viewCoSIAn(obj, "gex")
    expect_s3_class(result, "data.frame")
})

test_that("viewCoSIAn returns metric slot", {
    obj <- make_cosian()
    result <- viewCoSIAn(obj, "metric")
    expect_s3_class(result, "data.frame")
})

test_that("viewCoSIAn errors on invalid slot name", {
    obj <- make_cosian()
    expect_error(viewCoSIAn(obj, "invalid_slot"))
})

# getConversion uses AnnotationDbi (local org.*.eg.db packages) and HomoloGene
# (bundled data), so these tests do not require network access.

test_that("getConversion returns a CoSIAn object", {
    obj <- make_cosian(o_species = "h_sapiens", map_species = "h_sapiens")
    result <- getConversion(obj)
    expect_s4_class(result, "CoSIAn")
})

test_that("getConversion populates the converted_id slot", {
    obj <- make_cosian(o_species = "h_sapiens", map_species = "h_sapiens")
    result <- getConversion(obj)
    expect_s3_class(result@converted_id, "data.frame")
    expect_gt(nrow(result@converted_id), 0)
})

test_that("same-species conversion produces expected column names", {
    obj <- make_cosian(
        o_species = "h_sapiens",
        output_ids = c("Ensembl_id", "Symbol"),
        map_species = "h_sapiens"
    )
    result <- getConversion(obj)
    cols <- colnames(result@converted_id)
    expect_true(any(grepl("h_sapiens_ensembl_id", cols)))
    expect_true(any(grepl("h_sapiens_symbol", cols)))
})

test_that("cross-species conversion with HomoloGene produces output columns for both species", {
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        map_species = "m_musculus"
    )
    result <- getConversion(obj)
    cols <- colnames(result@converted_id)
    expect_true(any(grepl("h_sapiens_ensembl_id", cols)))
    expect_true(any(grepl("m_musculus_ensembl_id", cols)))
})

test_that("getConversion deduplicates gene_set input", {
    obj <- make_cosian(
        gene_set = c("ENSG00000008710", "ENSG00000008710"),
        o_species = "h_sapiens",
        map_species = "h_sapiens"
    )
    result <- getConversion(obj)
    hs_col <- result@converted_id[["h_sapiens_ensembl_id"]]
    expect_equal(sum(hs_col == "ENSG00000008710", na.rm = TRUE), 1L)
})

test_that("getConversion with NCBIOrtho requires network", {
    skip_if_offline()
    obj <- make_cosian(
        o_species = c("h_sapiens", "m_musculus"),
        output_ids = "Ensembl_id",
        ortholog_database = "NCBIOrtho",
        map_species = "m_musculus"
    )
    result <- getConversion(obj)
    expect_s4_class(result, "CoSIAn")
    expect_gt(nrow(result@converted_id), 0)
})

#' getGExMetrics Generic
#'
#' @param object CoSIAn object with all user accessible slots filled with
#' converted_id slot filled
#' @return initializes a generic function for getGExMetrics as preparation for
#' defining the getGExMetrics Method
#' @export
#' @import ExperimentHub
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
setGeneric("getGExMetrics", function(object) standardGeneric("getGExMetrics"))
# CoSIAn getGEx
################################################################################
#' getGExMetrics Method
#'
#' @param object CoSIAn object with all user accessible slots filled with
#' converted_id slot filled
#'
#' @return CoSIAn Object with metric slot filled
#' @export
#' @importFrom dplyr group_by summarise
#' @importFrom tibble remove_rownames column_to_rownames
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
#'         "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("r_norvegicus"),
#'     metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
#' Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
#' @references Kohl M (2022). MKdescr: Descriptive Statistics. R package version 
#' 0.8, https://github.com/stamats/MKdescr.
#' @references Zhang JD, Hatje K, Sturm G, Broger C, Ebeling M, Burtin M, Terzi 
#' F, Pomposiello SI, Badi L (2017). “Detect tissue heterogeneity in gene 
#' expression data with BioQC.” BMC Genomics, 18(1), 277. 
#' http://accio.github.io/BioQC/.
setMethod("getGExMetrics", signature(object = "CoSIAn"), function(object) {
    id_dataframe <- object@converted_id
    id_dataframe <- as.data.frame(id_dataframe)
    map_species <- object@map_species
    map_species <- as.character(map_species)
    Converted_Species_SWITCH <- Vectorize(
        vectorize.args = "map_species",
        FUN = function(map_species) {
            switch(as.character(map_species),
                h_sapiens = "h_sapiens_ensembl_id",
                m_musculus = "m_musculus_ensembl_id",
                r_norvegicus = "r_norvegicus_ensembl_id",
                d_rerio = "d_rerio_ensembl_id",
                d_melanogaster = "d_melanogaster_ensembl_id",
                c_elegans = "c_elegans_ensembl_id",
                stop("Invalid map_species in CoSIAn Object. Make sure the
            species in the map_species slot are an avalible model organism and
            are in the correct format.")
            )
        }
    )
    map_species <- Converted_Species_SWITCH(map_species)
    id_dataframe <- dplyr::select(
        id_dataframe,
        tidyselect::matches(map_species)
    )
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "h_sapiens")] <- "h_sapiens_ensembl_id"
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "m_musculus")] <- "m_musculus_ensembl_id"
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "r_norvegicus")] <- "r_norvegicus_ensembl_id"
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "d_rerio")] <- "d_rerio_ensembl_id"
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "d_melanogaster")] <- "d_melanogaster_ensembl_id"
    colnames(id_dataframe)[which(names(id_dataframe) ==
        "c_elegans")] <- "c_elegans_ensembl_id"
    map_tissues <- object@map_tissues
    map_tissues <- as.character(map_tissues)
    Species_SWITCH <- Vectorize(
        vectorize.args = "map_species",
        FUN = function(map_species) {
            switch(as.character(map_species),
                h_sapiens_ensembl_id = "Homo_sapiens",
                m_musculus_ensembl_id = "Mus_musculus",
                r_norvegicus_ensembl_id = "Rattus_norvegicus",
                d_rerio_ensembl_id = "Danio_rerio",
                d_melanogaster_ensembl_id = "Drosophila_melanogaster",
                c_elegans_ensembl_id = "Caenorhabditis_elegans",
                stop("Invalid map_species in CoSIAn Object. Make sure the
            species in the map_species slot are an avalible model organism and
                 are in the correct format.")
            )
        }
    )
    map_species <- Species_SWITCH(map_species)
    metric_type <- object@metric_type
    metric_type <- as.character(metric_type)
    CoSIAdata_load <- function(map_species) {
        eh <- ExperimentHub::ExperimentHub()
        merged_CoSIAdata <- data.frame(matrix(ncol = 9, nrow = 0))
        colnames(merged_CoSIAdata) <- c(
            "Anatomical_entity_name", "Ensembl_ID",
            "Sample_size", "VST", "Experiment_ID",
            "Anatomical_entity_ID", "Species",
            "Scaled_Median_VST", "mad"
        )
        if (any(map_species == "Mus_musculus")) {
            mm_EH_File <- eh[["EH7859"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, mm_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(map_species == "Rattus_norvegicus")) {
            rn_EH_File <- eh[["EH7860"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, rn_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(map_species == "Danio_rerio")) {
            dr_EH_File <- eh[["EH7861"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, dr_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(map_species == "Homo_sapiens")) {
            hs_EH_File <- eh[["EH7858"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, hs_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(map_species == "Caenorhabditis_elegans")) {
            ce_EH_File <- eh[["EH7863"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, ce_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(map_species == "Drosophila_melanogaster")) {
            dm_EH_File <- eh[["EH7862"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, dm_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else {
            stop("map_species in CoSIAn Object. Make sure the species in
            the map_species slot are avalible organisms through CoSIA and are in
            the correct format.")
        }
        return(merged_CoSIAdata)
    }

    merged_CoSIAdata <- lapply(map_species, CoSIAdata_load)
    filter_species <- dplyr::bind_rows(merged_CoSIAdata)
    rm(merged_CoSIAdata)
    
    #Adapted from the Mkdescr package under the license (LGPL-3)
    CV_function <- function(x, na.rm = FALSE) {
        stopifnot(is.numeric(x))
        if (na.rm) {
            x <- x[!is.na(x)]
        }
        if (any(x < 0)) {
            stop("Your data must be greater than zero!")
        }
        stats::sd(x, na.rm = FALSE) / stats::median(x)
    }

    # Adapted from BioQC packages under the license (GPL)
    DS_function <- function(type, mat) {
        Shannon_Entropy <- function(x) ifelse(x == 0, 0, x * log2(x))
        Diversity <- function(x) {
            rel <- x / sum(x, na.rm = TRUE)
            -sum(Shannon_Entropy(rel))
        }
        if (type == "Specificity") {
            mat.rel <- apply(mat, 2L, function(x) x / sum(x, na.rm = TRUE))
            speci <- apply(mat.rel, 1L, function(x) {
                gm <- mean(x, na.rm = TRUE)
                rel <- x / gm
                mean(Shannon_Entropy(rel), na.rm = TRUE)
            })
            speci <- speci / log2(ncol(mat))
            return(speci)
        }
        if (type == "Diversity") {
            res <- apply(mat, 2L, Diversity)
            res <- res / log2(nrow(mat))
            return(res)
        } else {
            stop("Incorrect Type")
        }
    }



    CV_Tissue <- function(map_species, map_tissues) {
        filter_tissue <- dplyr::filter(
            filter_species,
            Anatomical_entity_name %in% map_tissues
        )
        id <- as.vector(t(id_dataframe))
        filter_gene <- dplyr::filter(filter_tissue, Ensembl_ID %in% id)
        filter_gex <- filter_gene %>% tidyr::unnest(VST)
        filter_gex$VST <- as.numeric(filter_gex$VST)
        CV_Tissue <- filter_gex %>%
            dplyr::group_by(Ensembl_ID, Anatomical_entity_name, Species) %>%
            dplyr::summarise(CV_Tissue = CV_function(VST, na.rm = FALSE))
        cv_tissue <- tidyr::pivot_wider(CV_Tissue,
            names_from = Species,
            values_from = CV_Tissue
        )
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Homo_sapiens")] <- "h_sapiens_CV_tissue"
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Mus_musculus")] <- "m_musculus_CV_tissue"
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Rattus_norvegicus")] <- "r_norvegicus_CV_tissue"
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Danio_rerio")] <- "d_rerio_CV_Tissue"
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Drosophila_melanogaster")] <- "d_melanogaster_CV_tissue"
        colnames(cv_tissue)[which(names(cv_tissue) ==
            "Caenorhabditis_elegans")] <- "c_elegans_CV_tissue"
        for (i in seq_len(length(colnames(id_dataframe)))) {
            id <- colnames(id_dataframe)[i]
            id_dataframe <- id_dataframe %>%
                merge(., cv_tissue, by.x = id, by.y = "Ensembl_ID")
        }
        id_dataframe <- id_dataframe[, colSums(is.na(id_dataframe)) <
            nrow(id_dataframe)]
        id_dataframe <- id_dataframe %>%
            dplyr::select(order(colnames(id_dataframe), decreasing = TRUE))
        id_dataframe <- id_dataframe %>%
            dplyr::filter(dplyr::if_all(
                tidyselect::starts_with("Anatomical_entity_name"),
                ~ Anatomical_entity_name.x == .x
            ))
        duplicated_columns <- duplicated(as.list(id_dataframe))
        id_dataframe <- id_dataframe[!duplicated_columns]
        id_dataframe <- id_dataframe %>%
            dplyr::rename_with(~ stringr::str_remove(., c(".x")))
        CV_Tissue <- id_dataframe %>%
            dplyr::rename_with(~ stringr::str_remove(., c(".y")))
        colnames(CV_Tissue)[which(names(CV_Tissue) ==
            "Anatomical_enti_name.y")] <- "Anatomical_entity_name"
        CV_Tissue <- unique(CV_Tissue)
        return(CV_Tissue)
    }

    CV_Species <- function(map_species, map_tissues) {
        id <- as.vector(t(id_dataframe))
        filter_gene <- dplyr::filter(filter_species, Ensembl_ID %in% id)
        filter_gex <- filter_gene %>% tidyr::unnest(VST)
        filter_gex$VST <- as.numeric(filter_gex$VST)
        CV_Species <- filter_gex %>%
            dplyr::group_by(Ensembl_ID, Species) %>%
            dplyr::summarise(CV_Species = CV_function(VST, na.rm = FALSE))
        cv_species <- tidyr::pivot_wider(CV_Species,
            names_from = Species,
            values_from = CV_Species
        )
        colnames(cv_species)[which(names(cv_species) ==
            "Homo_sapiens")] <- "h_sapiens_CV_species"
        colnames(cv_species)[which(names(cv_species) ==
            "Mus_musculus")] <- "m_musculus_CV_species"
        colnames(cv_species)[which(names(cv_species) ==
            "Rattus_norvegicus")] <- "r_norvegicus_CV_species"
        colnames(cv_species)[which(names(cv_species) ==
            "Danio_rerio")] <- "d_rerio_CV_species"
        colnames(cv_species)[which(names(cv_species) ==
            "Drosophila_melanogaster")] <- "d_melanogaster_CV_species"
        colnames(cv_species)[which(names(cv_species) ==
            "Caenorhabditis_elegans")] <- "c_elegans_CV_species"
        for (i in seq_len(length(colnames(id_dataframe)))) {
            id <- colnames(id_dataframe)[i]
            id_dataframe <- id_dataframe %>%
                merge(., cv_species, by.x = id, by.y = "Ensembl_ID")
        }
        id_dataframe <- id_dataframe[, colSums(is.na(id_dataframe)) <
            nrow(id_dataframe)]
        id_dataframe <- id_dataframe %>%
            dplyr::select(order(colnames(id_dataframe), decreasing = TRUE))
        id_dataframe <- id_dataframe %>%
            dplyr::rename_with(~ stringr::str_remove(., c(".x")))
        CV_Species <- id_dataframe %>%
            dplyr::rename_with(~ stringr::str_remove(., c(".y")))
        CV_Species <- unique(CV_Species)
        return(CV_Species)
    }

    # DS_Gene : output genes restricted by mapped tissues and gene set
    DS_Gene <- function(map_species, map_tissues) {
        filter_tissue <- dplyr::filter(
            filter_species,
            Anatomical_entity_name %in% map_tissues
        )
        id <- as.vector(t(id_dataframe))
        filter_gene <- dplyr::filter(filter_tissue, Ensembl_ID %in% id)
        filter_gene$Scaled_Median_VST <- as.numeric(
            filter_gene$Scaled_Median_VST
        )
        filter_gex <- dplyr::select(
            filter_gene, Anatomical_entity_name,
            Scaled_Median_VST, Ensembl_ID
        )
        filter_gex_D <- filter_gex %>%
            tidyr::pivot_wider(
                names_from = Ensembl_ID,
                values_from = Scaled_Median_VST
            )
        filter_gex_D <- filter_gex_D %>%
            remove_rownames() %>%
            tibble::column_to_rownames(var = "Anatomical_entity_name")
        filter_gex_D <- data.matrix(filter_gex_D, )
        ENTROPY_DIVERSITY_G <- data.frame(DS_function(
            "Diversity",
            filter_gex_D
        )) # across genes
        colnames(ENTROPY_DIVERSITY_G)[which(names(ENTROPY_DIVERSITY_G) ==
            "DS_function..Diversity...filter_gex_D.")] <- "Diversity"

        filter_gex <- data.frame(filter_gex)
        filter_gex_S <- filter_gex %>%
            tidyr::pivot_wider(
                names_from = Anatomical_entity_name,
                values_from = Scaled_Median_VST
            )
        filter_gex_S <- filter_gex_S %>%
            remove_rownames() %>%
            column_to_rownames(var = "Ensembl_ID")
        filter_gex_S <- data.matrix(filter_gex_S, )
        ENTROPY_SPECIFITY_G <- data.frame(DS_function(
            "Specificity",
            filter_gex_S
        )) # across tissues
        colnames(ENTROPY_SPECIFITY_G)[which(names(ENTROPY_SPECIFITY_G) ==
            "DS_function..Specificity...filter_gex_S.")] <- "Specificity"

        DS <- merge(ENTROPY_SPECIFITY_G, ENTROPY_DIVERSITY_G, by = "row.names")
        colnames(DS)[which(names(DS) == "Row.names")] <- "Ensembl_ID"
        DS$Ensembl_ID <- as.character(DS$Ensembl_ID)
        Species <- dplyr::select(filter_gene, Species, Ensembl_ID)
        DS <- merge(DS, Species, by = "Ensembl_ID")
        DS <- data.frame(unique(DS))
        rownames(DS) <- NULL
        return(DS)
    }

    # DS_Tissue: output is tissues restricted to mapped tissues and gene set
    DS_Tissue <- function(map_species, map_tissues) {
        gene_set<- object@gene_set
        if (length(gene_set)<2){
          stop("DS_Tissue requires more than one gene.")
        }
        DS <- data.frame(matrix(ncol = 4, nrow = 0))
        colnames(DS)[which(names(DS) ==
            "map_tissues")] <- "Anatomical_entity_name"
        for (x in seq_len(length(map_species))) {
            filter_specific <- dplyr::filter(
                filter_species,
                Species == map_species[x]
            )
            filter_tissue <- dplyr::filter(
                filter_specific,
                Anatomical_entity_name %in% map_tissues
            )
            id <- as.vector(t(id_dataframe))
            filter_gene <- dplyr::filter(filter_tissue, Ensembl_ID %in% id)
            filter_gene$Scaled_Median_VST <- as.numeric(
                filter_gene$Scaled_Median_VST
            )
            filter_gex <- dplyr::select(
                filter_gene, Anatomical_entity_name,
                Scaled_Median_VST, Ensembl_ID
            )

            filter_gex_D <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Anatomical_entity_name,
                    values_from = Scaled_Median_VST
                )
            filter_gex_D <- filter_gex_D %>%
                remove_rownames() %>%
                tibble::column_to_rownames(var = "Ensembl_ID")
            filter_gex_D <- data.matrix(filter_gex_D, )
            ENTROPY_DIVERSITY_T <- data.frame(DS_function(
                "Diversity",
                filter_gex_D
            )) # across genes
            colnames(ENTROPY_DIVERSITY_T)[which(names(ENTROPY_DIVERSITY_T) ==
                "DS_function..Diversity...filter_gex_D.")] <- "Diversity"

            filter_gex <- data.frame(filter_gex)
            filter_gex_S <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Ensembl_ID,
                    values_from = Scaled_Median_VST
                )
            filter_gex_S <- filter_gex_S %>%
                remove_rownames() %>%
                column_to_rownames(var = "Anatomical_entity_name")
            filter_gex_S <- data.matrix(filter_gex_S, )
            ENTROPY_SPECIFITY_T <- data.frame(DS_function(
                "Specificity",
                filter_gex_S
            )) # across tissues
            colnames(ENTROPY_SPECIFITY_T)[which(names(ENTROPY_SPECIFITY_T) ==
                "DS_function..Specificity...filter_gex_S.")] <- "Specificity"

            SDS <- merge(ENTROPY_SPECIFITY_T, ENTROPY_DIVERSITY_T,
                by = "row.names"
            )
            colnames(SDS)[which(names(SDS) ==
                "Row.names")] <- "Anatomical_entity_name"
            SDS$Anatomical_entity_name <- as.character(
                SDS$Anatomical_entity_name
            )
            Species <- dplyr::select(
                filter_gene,
                Species,
                Anatomical_entity_name
            )
            SDS <- merge(SDS, Species, by = "Anatomical_entity_name")
            DS <- rbind(DS, SDS)
        }
        DS <- data.frame(unique(DS))
        rownames(DS) <- NULL
        return(DS)
    }
    # DS_Gene_all: genes only restricted to selected genes across all tissues
    DS_Gene_all <- function(map_species) {
        DS <- data.frame(matrix(ncol = 4, nrow = 0))
        colnames(DS)[1] <- "Ensembl_ID"
        for (x in seq_len(length(map_species))) {
            filter_specific <- dplyr::filter(
                filter_species,
                Species == map_species[x]
            )
            id <- as.vector(t(id_dataframe))
            filter_gene <- dplyr::filter(filter_specific, Ensembl_ID %in% id)
            filter_gene$Scaled_Median_VST <- as.numeric(
                filter_gene$Scaled_Median_VST
            )
            filter_gex <- dplyr::select(
                filter_gene,
                Anatomical_entity_name,
                Scaled_Median_VST,
                Ensembl_ID
            )

            filter_gex_D <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Ensembl_ID,
                    values_from = Scaled_Median_VST
                )
            filter_gex_D <- filter_gex_D %>%
                remove_rownames() %>%
                tibble::column_to_rownames(var = "Anatomical_entity_name")
            filter_gex_D <- data.matrix(filter_gex_D, )
            ENTROPY_DIVERSITY_G <- data.frame(DS_function(
                "Diversity",
                filter_gex_D
            )) # across genes
            colnames(ENTROPY_DIVERSITY_G)[which(names(ENTROPY_DIVERSITY_G) ==
                "DS_function..Diversity...filter_gex_D.")] <- "Diversity"

            filter_gex <- data.frame(filter_gex)
            filter_gex_S <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Anatomical_entity_name,
                    values_from = Scaled_Median_VST
                )
            filter_gex_S <- filter_gex_S %>%
                remove_rownames() %>%
                column_to_rownames(var = "Ensembl_ID")
            filter_gex_S <- data.matrix(filter_gex_S, )
            ENTROPY_SPECIFITY_G <- data.frame(DS_function(
                "Specificity",
                filter_gex_S
            )) # across tissues
            colnames(ENTROPY_SPECIFITY_G)[which(names(ENTROPY_SPECIFITY_G) ==
                "DS_function..Specificity...filter_gex_S.")] <- "Specificity"

            SDS <- merge(ENTROPY_SPECIFITY_G, ENTROPY_DIVERSITY_G,
                by = "row.names"
            )
            colnames(SDS)[which(names(SDS) == "Row.names")] <- "Ensembl_ID"
            SDS$Ensembl_ID <- as.character(SDS$Ensembl_ID)
            Species <- dplyr::select(filter_gene, Species, Ensembl_ID)
            SDS <- merge(SDS, Species, by = "Ensembl_ID")
            DS <- rbind(DS, SDS)
        }
        DS <- data.frame(unique(DS))
        rownames(DS) <- NULL
        return(DS)
    }

    # DS_Tissue_All:tissues restricted to mapped tissues across all genes
    DS_Tissue_all <- function(map_species, map_tissues) {
        DS <- data.frame(matrix(ncol = 4, nrow = 0))
        colnames(DS)[which(names(DS) ==
            "map_tissues")] <- "Anatomical_entity_name"
        for (x in seq_len(length(map_species))) {
            filter_specific <- dplyr::filter(
                filter_species,
                Species == map_species[x]
            )
            filter_tissue <- dplyr::filter(
                filter_specific,
                Anatomical_entity_name %in% map_tissues
            )
            filter_tissue$Scaled_Median_VST <- as.numeric(
                filter_tissue$Scaled_Median_VST
            )
            filter_gex <- dplyr::select(
                filter_tissue, Anatomical_entity_name,
                Scaled_Median_VST, Ensembl_ID
            )

            filter_gex_D <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Anatomical_entity_name,
                    values_from = Scaled_Median_VST
                )
            filter_gex_D <- filter_gex_D %>%
                remove_rownames() %>%
                tibble::column_to_rownames(var = "Ensembl_ID")
            filter_gex_D <- data.matrix(filter_gex_D, )
            ENTROPY_DIVERSITY_T <- data.frame(DS_function(
                "Diversity",
                filter_gex_D
            )) # across genes
            colnames(ENTROPY_DIVERSITY_T)[which(names(ENTROPY_DIVERSITY_T) ==
                "DS_function..Diversity...filter_gex_D.")] <- "Diversity"

            filter_gex <- data.frame(filter_gex)
            filter_gex_S <- filter_gex %>%
                tidyr::pivot_wider(
                    names_from = Ensembl_ID,
                    values_from = Scaled_Median_VST
                )
            filter_gex_S <- filter_gex_S %>%
                remove_rownames() %>%
                column_to_rownames(var = "Anatomical_entity_name")
            filter_gex_S <- data.matrix(filter_gex_S, )
            ENTROPY_SPECIFITY_T <- data.frame(DS_function(
                "Specificity",
                filter_gex_S
            )) # across tissues
            colnames(ENTROPY_SPECIFITY_T)[which(names(ENTROPY_SPECIFITY_T) ==
                "DS_function..Specificity...filter_gex_S.")] <- "Specificity"

            SDS <- merge(ENTROPY_SPECIFITY_T, ENTROPY_DIVERSITY_T,
                by = "row.names"
            )
            colnames(SDS)[which(names(SDS) ==
                "Row.names")] <- "Anatomical_entity_name"
            SDS$Anatomical_entity_name <- as.character(
                SDS$Anatomical_entity_name
            )
            Species <- dplyr::select(
                filter_tissue,
                Species, Anatomical_entity_name
            )
            SDS <- merge(SDS, Species, by = "Anatomical_entity_name")
            DS <- rbind(DS, SDS)
        }
        DS <- data.frame(unique(DS))
        rownames(DS) <- NULL
        return(DS)
    }


    if (metric_type == "CV_Tissue") {
        CV_Tissue <- CV_Tissue(map_species, map_tissues)
        object@metric <- CV_Tissue
    } else if (metric_type == "CV_Species") {
        CV_Species <- CV_Species(map_species, map_tissues)
        object@metric <- CV_Species
    } else if (metric_type == "DS_Gene") {
        DS_Gene <- DS_Gene(map_species, map_tissues)
        object@metric <- DS_Gene
    } else if (metric_type == "DS_Tissue") {
        DS_Tissue <- DS_Tissue(map_species, map_tissues)
        object@metric <- DS_Tissue
    } else if (metric_type == "DS_Gene_all") {
        DS_Gene_all <- DS_Gene_all(map_species)
        object@metric <- DS_Gene_all
    } else if (metric_type == "DS_Tissue_all") {
        DS_Tissue_all <- DS_Tissue_all(map_species, map_tissues)
        object@metric <- DS_Tissue_all
    } else {
        (stop("Invalid metric type"))
    }

    return(object)
})

#' getConversion Generic
#'
#' @param object CoSIAn object with all user accessible slots filled
#'
#' @return initializes a generic function for getConversion as preparation for
#' defining the getConversion Method
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c(
#'         "d_melanogaster", "d_rerio",
#'         "c_elegans", "r_norvegicus"
#'     ),
#'     output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
#'     ortholog_database = "HomoloGene", map_tissues = "heart",
#'     map_species = c("r_norvegicus"), metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
setGeneric("getConversion", function(object) standardGeneric("getConversion"))
################################################################################
#' getConversion Method
#' @method get conversions
#' @param object CoSIAn object with all user accessible slots filled
#'
#' @return CoSIAn object with converted_id slot filled
#' @export
#' @importFrom magrittr %>%
#' @importFrom stats na.omit
#' @importFrom tidyselect contains
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c(
#'         "d_melanogaster", "d_rerio",
#'         "c_elegans", "r_norvegicus"
#'     ),
#'     output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
#'     ortholog_database = "HomoloGene", map_tissues = "heart",
#'     map_species = c("r_norvegicus"), metric_type = "DS_Gene"
#' )
#' Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
setMethod("getConversion", signature(object = "CoSIAn"), function(object) {
    # Set each slot of the object into a variable to be used inside the code
    input_species <- object@i_species
    input_id <- object@input_id
    input <- object@gene_set
    input <- unique(input)
    if (input_id == "Ensembl_id") {
        # Use remove_version_numbers to remove ensembl id versions(after the .)
        input <- remove_version_numbers(input, input_species)
    }
    input <- as.character(input)
    output_ids <- object@output_ids
    output_species <- object@o_species
    tool <- object@mapping_tool
    ortholog_database <- object@ortholog_database
    species_data <- data.frame(input)
    c_name <- tolower(paste(input_species, input_id, sep = "_"))
    colnames(species_data)[which(names(species_data) == "input")] <- c_name
    # changes name to more formal names
    for (index in seq(length(output_species))) {
        os <- paste(output_species[index], sep = " ")
        switch(input_species,
            h_sapiens = {
                hs_data <- h_sapiens(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                hs_data <- data.frame(lapply(hs_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, hs_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, hs_data)
                }
            },
            m_musculus = {
                mm_data <- m_musculus(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                mm_data <- data.frame(lapply(mm_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, mm_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, mm_data)
                }
            },
            r_norvegicus = {
                rn_data <- r_norvegicus(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                rn_data <- data.frame(lapply(rn_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, rn_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, rn_data)
                }
            },
            d_rerio = {
                dr_data <- d_rerio(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                dr_data <- data.frame(lapply(dr_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, dr_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, dr_data)
                }
            },
            c_elegans = {
                ce_data <- c_elegans(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                ce_data <- data.frame(lapply(ce_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, ce_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, ce_data)
                }
            },
            d_melanogaster = {
                dm_data <- d_melanogaster(
                    input_id, input, output_ids,
                    output_species[index], tool, ortholog_database
                )
                dm_data <- data.frame(lapply(dm_data, as.character))
                result <- try(
                    {
                        dplyr::full_join(species_data, dm_data)
                    },
                    silent = TRUE
                )
                if (is(result, "try-error")) {
                    warning(
                        "No orthologs were found for ", os,
                        " across all the genes provided by the user."
                    )
                } else {
                    species_data <- dplyr::full_join(species_data, dm_data)
                }
            },
            stop("Invalid i_species in CoSIAn Object.
            Make sure the species in the i_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    converted_id <- data.frame(unique(species_data))
    rownames(converted_id) <- seq(length=nrow(converted_id))
    object@converted_id<-converted_id
    return(object)
})
## Species Functions
# Caenorhabditis elegans
# Input data funneling in from the cross species conversion function
c_elegans <- function(input_id, input_dataset, output_ids, output_species, tool,
                      ortholog_database) {
    # if the user has choose the tool biomart this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_CE <- switch(output_species,
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 9606,
                    "celegans_gene_ensembl", "hsapiens_gene_ensembl",
                    ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 10090,
                    "celegans_gene_ensembl", "mmusculus_gene_ensembl",
                    ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 10116,
                    "celegans_gene_ensembl", "rnorvegicus_gene_ensembl",
                    ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 7955,
                    "celegans_gene_ensembl", "drerio_gene_ensembl",
                    ortholog_database
                )
            },
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 6239,
                    "celegans_gene_ensembl", "celegans_gene_ensembl",
                    ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "c_elegans", output_species, 7227,
                    "celegans_gene_ensembl", "dmelanogaster_gene_ensembl",
                    ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # Code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_CE <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 9606, org.Ce.eg.db::org.Ce.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 10090, org.Ce.eg.db::org.Ce.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 10116, org.Ce.eg.db::org.Ce.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 7955, org.Ce.eg.db::org.Ce.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 6239, org.Ce.eg.db::org.Ce.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "c_elegans",
                    output_species, 7227, org.Ce.eg.db::org.Ce.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    } else {
        # Code follows this path if the tool does not match possible options
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}

# Drosophila Melanogaster - Fruit Fly
# Input data funneling in from the cross species conversion function
d_melanogaster <- function(input_id, input_dataset, output_ids, output_species,
                           tool, ortholog_database) {
    # If the user has choose the tool biomaRt this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_DM <- switch(output_species,
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 9606,
                    "dmelanogaster_gene_ensembl", "hsapiens_gene_ensembl",
                    ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 10090,
                    "dmelanogaster_gene_ensembl", "mmusculus_gene_ensembl",
                    ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 10116,
                    "dmelanogaster_gene_ensembl", "rnorvegicus_gene_ensembl",
                    ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 7955,
                    "dmelanogaster_gene_ensembl", "drerio_gene_ensembl",
                    ortholog_database
                )
            },
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 6239,
                    "dmelanogaster_gene_ensembl", "celegans_gene_ensembl",
                    ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_melanogaster", output_species, 7227,
                    "dmelanogaster_gene_ensembl", "dmelanogaster_gene_ensembl",
                    ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_DM <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    9606, org.Dm.eg.db::org.Dm.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    10090, org.Dm.eg.db::org.Dm.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    10116, org.Dm.eg.db::org.Dm.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    7955, org.Dm.eg.db::org.Dm.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    6239, org.Dm.eg.db::org.Dm.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_melanogaster", output_species,
                    7227, org.Dm.eg.db::org.Dm.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # Code follows this path if the tool does not match possible options
    else {
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}
# d_rerio - Zebrafish
# input data funneling in from the cross species conversion function
d_rerio <- function(input_id, input_dataset, output_ids, output_species, tool,
                    ortholog_database) {
    # if the user has choose the tool biomart this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_DR <- switch(output_species,
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 9606,
                    "drerio_gene_ensembl", "hsapiens_gene_ensembl",
                    ortholog_database
                )
            },
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 6239,
                    "drerio_gene_ensembl", "celegans_gene_ensembl",
                    ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 7227,
                    "drerio_gene_ensembl", "dmelanogaster_gene_ensembl",
                    ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 10090,
                    "drerio_gene_ensembl", "mmusculus_gene_ensembl",
                    ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 7955,
                    "drerio_gene_ensembl", "drerio_gene_ensembl",
                    ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "d_rerio", output_species, 10116,
                    "drerio_gene_ensembl", "rnorvegicus_gene_ensembl",
                    ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_DR <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    9606, org.Dr.eg.db::org.Dr.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    10090, org.Dr.eg.db::org.Dr.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    7227, org.Dr.eg.db::org.Dr.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    7955, org.Dr.eg.db::org.Dr.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    6239, org.Dr.eg.db::org.Dr.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "d_rerio", output_species,
                    10116, org.Dr.eg.db::org.Dr.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # Code follows this path if the tool does not match possible options
    else {
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}

# Homo sapiens - Humans
# Input data funneling in from the cross species conversion function
h_sapiens <- function(input_id, input_dataset, output_ids, output_species, tool,
                      ortholog_database) {
    # if the user has choose the tool biomart this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_HS <- switch(output_species,
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 6239,
                    "hsapiens_gene_ensembl", "celegans_gene_ensembl",
                    ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 7227,
                    "hsapiens_gene_ensembl", "dmelanogaster_gene_ensembl",
                    ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 10090,
                    "hsapiens_gene_ensembl", "mmusculus_gene_ensembl",
                    ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 7955,
                    "hsapiens_gene_ensembl", "drerio_gene_ensembl",
                    ortholog_database
                )
            },
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 9606,
                    "hsapiens_gene_ensembl", "hsapiens_gene_ensembl",
                    ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "h_sapiens", output_species, 10116,
                    "hsapiens_gene_ensembl", "rnorvegicus_gene_ensembl",
                    ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
        return(output_data)
    }
    # code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_HS <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    9606, org.Hs.eg.db::org.Hs.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    10090, org.Hs.eg.db::org.Hs.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    7227, org.Hs.eg.db::org.Hs.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    7955, org.Hs.eg.db::org.Hs.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    6239, org.Hs.eg.db::org.Hs.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "h_sapiens", output_species,
                    10116, org.Hs.eg.db::org.Hs.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
        return(output_data)
    }
    # code follows this path if the tool does not match.
    else {
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}
# Mus musculus - Mouse
# Input data funneling in from the cross species conversion function
m_musculus <- function(input_id, input_dataset, output_ids, output_species,
                       tool, ortholog_database) {
    # if the user has choose the tool biomart this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_MM <- switch(output_species,
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 6239,
                    "mmusculus_gene_ensembl", "celegans_gene_ensembl",
                    ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 7227,
                    "mmusculus_gene_ensembl", "dmelanogaster_gene_ensembl",
                    ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 10090,
                    "mmusculus_gene_ensembl", "mmusculus_gene_ensembl",
                    ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 7955,
                    "mmusculus_gene_ensembl", "drerio_gene_ensembl",
                    ortholog_database
                )
            },
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 9606,
                    "mmusculus_gene_ensembl", "hsapiens_gene_ensembl",
                    ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "m_musculus", output_species, 10116,
                    "mmusculus_gene_ensembl", "rnorvegicus_gene_ensembl",
                    ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
                 organism and is in the correct format.")
        )
    }
    # code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_MM <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    9606, org.Mm.eg.db::org.Mm.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    10090, org.Mm.eg.db::org.Mm.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    7227, org.Mm.eg.db::org.Mm.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    7955, org.Mm.eg.db::org.Mm.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    6239, org.Mm.eg.db::org.Mm.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "m_musculus", output_species,
                    10116, org.Mm.eg.db::org.Mm.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # code follows this path if the tool does not match.
    else {
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}
# Rattus norvegicus- Rat
# Input data funneling in from the cross species conversion function
r_norvegicus <- function(input_id, input_dataset, output_ids, output_species,
                         tool, ortholog_database) {
    # if the user has choose the tool biomart this it the path the codes follows
    if (tool == "biomaRt") {
        Filter_BO_RN <- switch(output_species,
            c_elegans = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 6239,
                    "rnorvegicus_gene_ensembl",
                    "celegans_gene_ensembl", ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 7227,
                    "rnorvegicus_gene_ensembl",
                    "dmelanogaster_gene_ensembl", ortholog_database
                )
            },
            m_musculus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 10090,
                    "rnorvegicus_gene_ensembl",
                    "mmusculus_gene_ensembl", ortholog_database
                )
            },
            d_rerio = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 7955,
                    "rnorvegicus_gene_ensembl",
                    "drerio_gene_ensembl", ortholog_database
                )
            },
            h_sapiens = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 9606,
                    "rnorvegicus_gene_ensembl",
                    "hsapiens_gene_ensembl", ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- biomaRt(input_id, input_dataset, output_ids,
                    input_species = "r_norvegicus", output_species, 10116,
                    "rnorvegicus_gene_ensembl",
                    "rnorvegicus_gene_ensembl", ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # code follows this path if the user chooses annotationDBI as their tool
    else if (tool == "annotationDBI") {
        Filter_AO_RN <- switch(output_species,
            h_sapiens = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    9606, org.Rn.eg.db::org.Rn.eg.db,
                    org.Hs.eg.db::org.Hs.eg.db, ortholog_database
                )
            },
            m_musculus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    10090, org.Rn.eg.db::org.Rn.eg.db,
                    org.Mm.eg.db::org.Mm.eg.db, ortholog_database
                )
            },
            d_melanogaster = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    7227, org.Rn.eg.db::org.Rn.eg.db,
                    org.Dm.eg.db::org.Dm.eg.db, ortholog_database
                )
            },
            d_rerio = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    7955, org.Rn.eg.db::org.Rn.eg.db,
                    org.Dr.eg.db::org.Dr.eg.db, ortholog_database
                )
            },
            c_elegans = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    6239, org.Rn.eg.db::org.Rn.eg.db,
                    org.Ce.eg.db::org.Ce.eg.db, ortholog_database
                )
            },
            r_norvegicus = {
                output_data <- annotationDBI(input_id, input_dataset,
                    output_ids,
                    input_species = "r_norvegicus", output_species,
                    10116, org.Rn.eg.db::org.Rn.eg.db,
                    org.Rn.eg.db::org.Rn.eg.db, ortholog_database
                )
            },
            stop("Invalid o_species in CoSIAn Object.
            Make sure the species in the o_species slot is an avalible model
            organism and is in the correct format.")
        )
    }
    # code follows this path if the tool that does not match.
    else {
        stop("Invalid tool in CoSIAn Object.
             Make sure the tool is either annotationDBI or biomaRt.")
    }
}

# Tool functions
# annotationDBI
annotationDBI <- function(input_id, input_dataset, output_ids, input_species,
                          output_species, species_number, input_org, output_org,
                          ortholog_database) {
    # This function uses annotationDBI to convert between gene identifier
    # Switch function transitions the id names into the proper format for AD
    input_dataset <- as.character(input_dataset)
    ID_SWITCH <- Vectorize(vectorize.args = "ids", FUN = function(ids) {
        switch(as.character(ids),
            Entrez_id = "ENTREZID",
            Ensembl_id = "ENSEMBL",
            Symbol = "SYMBOL",
            stop("Invalid input_id or output_ids. The acceptable ids for
                 annotationDBI are Entrez_id, Ensembl_id, Ensembl_id_version,
                 Symbol, and Gene_name.")
        )
    })
    input_id <- ID_SWITCH(ids = input_id)
    output_ids <- ID_SWITCH(ids = output_ids)
    input_id <- as.character(input_id)
    output_ids <- as.character(output_ids)
    if (output_species == input_species) {
        annotationDbi_data <- AnnotationDbi::select(input_org,
            keys = input_dataset,
            columns = output_ids,
            keytype = input_id
        )
        colnames(annotationDbi_data)[which(names(annotationDbi_data) ==
            "ENSEMBL")] <- paste(output_species, "ensembl_id", sep = "_")
        colnames(annotationDbi_data)[which(names(annotationDbi_data) ==
            "ENTREZID")] <- paste(output_species, "entrez_id", sep = "_")
        colnames(annotationDbi_data)[which(names(annotationDbi_data) ==
            "ENSEMBLIDVERSION")] <- paste(output_species,
            "ensembl_id_version",
            sep = "_"
        )
        colnames(annotationDbi_data)[which(names(annotationDbi_data) ==
            "GENENAME")] <- paste(output_species, "gene_name", sep = "_")
        colnames(annotationDbi_data)[which(names(annotationDbi_data) ==
            "SYMBOL")] <- paste(output_species, "symbol", sep = "_")
        return(annotationDbi_data)
    } else {
        # Runs annotationdbi to convert EntrezID to conduct ortholog mapping
        output_data <- AnnotationDbi::select(input_org,
            keys = input_dataset,
            columns = c("ENTREZID"),
            keytype = input_id
        )
        # omits the NA values
        output_data <- na.omit(output_data)
        # send the entrezid ids through the homolog conversion
        id <- homolog(output_data$ENTREZID, species_number, ortholog_database)
        # make the EntrezID that were used for the conversion into species one
        names(output_data)[names(output_data) == "ENTREZID"] <- "species_one"
        # merge the dataframes with original ids and ortholog ids together
        merged_data <- merge.data.frame(data.frame(output_data), data.frame(id),
            by = "species_one"
        )
        # change column name to be representative of the input species
        colnames(merged_data)[which(names(merged_data) ==
            "species_one")] <- paste(input_species, "entrez_id", sep = "_")
        # change column name to be representative of the input species
        if (input_id != "ENTREZID") {
            entrez_id_col_name_input <- paste(input_species,
                "entrez_id",
                sep = "_"
            )
            merged_data <- merged_data %>%
                dplyr::select(-tidyselect::all_of(entrez_id_col_name_input))
        }
        # changes name to more formal names
        colnames(merged_data)[which(names(merged_data) ==
            "ENTREZID")] <- paste(input_species, "entrez_id", sep = "_")
        colnames(merged_data)[which(names(merged_data) ==
            "ENSEMBL")] <- paste(input_species, "ensembl_id", sep = "_")
        colnames(merged_data)[which(names(merged_data) ==
            "SYMBOL")] <- paste(input_species, "symbol", sep = "_")
        colnames(merged_data)[which(names(merged_data) ==
            "ENSEMBLIDVERSION")] <- paste(input_species,
            "ensembl_id_version",
            sep = "_"
        )
        colnames(merged_data)[which(names(merged_data) ==
            "GENENAME")] <- paste(input_species, "gene_name", sep = "_")
        ortho <- AnnotationDbi::select(output_org,
            keys = as.character(as.matrix(merged_data$species_two)),
            columns = output_ids,
            keytype = "ENTREZID"
        )
        # Convert to different gene identifiers
        # Determine the indices for the non-NA genes
        non_na <- which(is.na(ortho$ENTREZID) == FALSE)
        # Return only the genes with annotations using indices
        ortho <- ortho[non_na, ]
        # Determine the indices for the non-duplicated genes
        non_dups <- which(duplicated(ortho$ENTREZID) == FALSE)
        # Return only the non-duplicated genes using indices
        ortho <- ortho[non_dups, ]
        # make the ortholog conversion into a dataframe
        ortho <- data.frame(ortho)
        # merge the orthologs and original data
        names(ortho)[names(ortho) == "ENTREZID"] <- "species_two"
        merged_data_ortholog <- merge.data.frame(data.frame(ortho),
            data.frame(merged_data),
            by = "species_two"
        )
        colnames(merged_data_ortholog)[names(merged_data_ortholog) ==
            "species_two"] <- paste(output_species, "entrez_id", sep = "_")
        if ("ENTREZID" %in% output_ids == FALSE) {
            entrez_id_col_output <- paste(output_species,
                "entrez_id",
                sep = "_"
            )
            merged_data_ortholog <- merged_data_ortholog %>%
                dplyr::select(-tidyselect::all_of(entrez_id_col_output))
        }
        colnames(merged_data_ortholog)[which(names(merged_data_ortholog) ==
            "ENTREZID")] <- paste(output_species, "entrez_id", sep = "_")
        colnames(merged_data_ortholog)[which(names(merged_data_ortholog) ==
            "ENSEMBL")] <- paste(output_species, "ensembl_id", sep = "_")
        colnames(merged_data_ortholog)[which(names(merged_data_ortholog) ==
            "SYMBOL")] <- paste(output_species, "symbol", sep = "_")
        colnames(merged_data_ortholog)[which(names(merged_data_ortholog) ==
            "ENSEMBLIDVERSION")] <- paste(output_species,
            "ensembl_id_version",
            sep = "_"
        )
        colnames(merged_data_ortholog)[which(names(merged_data_ortholog) ==
            "GENENAME")] <- paste(output_species, "gene_name", sep = "_")
        merged_data_ortholog <- merged_data_ortholog[!duplicated(as.list(
            merged_data_ortholog
        ))]
        return(merged_data_ortholog)
    }
}

# biomaRt

biomaRt <- function(input_id, input_dataset, output_ids, input_species,
                    output_species, species_number, species_dataset,
                    output_species_dataset, ortholog_database) {
    species_dataset <- as.character(species_dataset)
    # Make sure ids are in the class character
    input_id <- as.character(input_id)
    output_ids <- as.character(output_ids)
    # A switch function that renames the user ids into bioconductor format
    ID_SWITCH <- Vectorize(vectorize.args = "ids", FUN = function(ids) {
        switch(as.character(ids),
            Entrez_id = "entrezgene_id",
            Ensembl_id = "ensembl_gene_id",
            Symbol = "external_gene_name",
            stop("Invalid input_id or output_ids.
                 The acceptable ids for biomaRt is Entrez_id,
                 Ensembl_id, and Symbol")
        )
    })
    # set the id names to their new formats
    input_id <- ID_SWITCH(ids = input_id)
    output_ids <- ID_SWITCH(ids = output_ids)
    if (input_species == output_species) {
        # goes through this path if the input and output species are the same
        # pulls the biomaRt object for the species species that has been chosen
        mart <- biomaRt::useMart("ensembl", dataset = species_dataset)
        attributes <- c(output_ids, input_id)
        attributes <- as.character(attributes)
        filters <- input_id # sets the filters as the input vales
        filters <- as.character(filters)
        input_dataset <- as.character(input_dataset)
        # run conversion through biomaRt
        output_data <- biomaRt::getBM(
            attributes = attributes,
            filters = filters,
            values = input_dataset,
            mart = mart,
            uniqueRows = TRUE,
            bmHeader = FALSE
        )
        colnames(output_data)[which(names(output_data) ==
            "ensembl_gene_id")] <- paste(input_species, "ensembl_id", sep = "_")
        colnames(output_data)[which(names(output_data) ==
            "entrezgene_id")] <- paste(input_species, "entrez_id", sep = "_")
        colnames(output_data)[which(names(output_data) ==
            "external_gene_name")] <- paste(input_species, "symbol", sep = "_")
        output_data <- output_data %>% dplyr::select(-contains("."))
        return(output_data) # return the biomaRt output
    }
    # goes through this path if the input and output species are different
    else {
        # sets up biomart for species input
        mart <- biomaRt::useMart("ensembl", dataset = species_dataset)
        # sets input ids and entrezids as attributes (output values)
        attributes <- c("entrezgene_id", input_id)
        filters <- input_id # set the input ids as the filter (input values)
        # run the convesion through biomaRt
        output_data <- biomaRt::getBM(
            attributes = attributes,
            filters = filters,
            values = input_dataset,
            mart = mart,
            uniqueRows = TRUE,
            bmHeader = FALSE
        )
        output_data <- na.omit(output_data) # omit the NA values
        # run the homolog function and get the entrezids for the other species
        id <- homolog(
            output_data$entrezgene_id,
            species_number,
            ortholog_database
        )
        # this makes sure that our homologous gene list is in a dataframe
        id <- data.frame(id)
        names(output_data)[names(output_data) ==
            "entrezgene_id"] <- "species_one"
        # change the name of the input id
        colnames(output_data)[which(names(output_data) ==
            "ensembl_gene_id")] <- paste(input_species, "ensembl_id", sep = "_")
        colnames(output_data)[which(names(output_data) ==
            "ensembl_gene_id_version")] <- paste(input_species,
            "ensembl_id_version",
            sep = "_"
        )
        colnames(output_data)[which(names(output_data) ==
            "external_gene_name")] <- paste(input_species, "symbol", sep = "_")
        # merge the two dataframes
        merged_data <- merge.data.frame(data.frame(output_data), data.frame(id),
            by = "species_one"
        )
        colnames(merged_data)[which(names(merged_data) ==
            "species_one")] <- paste(input_species, "entrez_id", sep = "_")
        # set the biomart species to the new species
        marts <- biomaRt::useMart("ensembl", dataset = output_species_dataset)
        ortho <- biomaRt::getBM(
            attributes = c(output_ids, "entrezgene_id"),
            filters = "entrezgene_id", values = id$species_two, mart = marts,
            uniqueRows = TRUE, bmHeader = FALSE
        )
        # run the homologous entrezids to the other gene identifiers
        # pick non na values from ortholog conversion
        non_na <- which(is.na(ortho$entrezgene_id) == FALSE)
        # subset only nonna values
        ortho <- ortho[non_na, ]
        # subset only duplicates
        non_dups <- which(duplicated(ortho$entrezgene_id) == FALSE)
        # subset only duplicates
        ortho <- ortho[non_dups, ]
        # set the ortho variable as a dataframe
        ortho <- data.frame(ortho)
        # rename the entrezid as species two
        names(ortho)[names(ortho) == "entrezgene_id"] <- "species_two"
        # merge the ortholog dataframe and the original data
        merged_species_data <- merge.data.frame(data.frame(ortho),
            data.frame(merged_data),
            by = "species_two"
        )
        merged_species_data <- merged_species_data[, !names(merged_species_data)
        %in% c("entrezgene_id.1")]
        # clean up names
        names(merged_species_data)[names(merged_species_data) ==
            "species_two"] <- paste(output_species, "entrez_id", sep = "_")
        colnames(merged_species_data)[which(names(merged_species_data) ==
            "entrezgene_id")] <- paste(output_species, "entrez_id", sep = "_")
        colnames(merged_species_data)[which(names(merged_species_data) ==
            "ensembl_gene_id")] <- paste(output_species,
            "ensembl_id",
            sep = "_"
        )
        colnames(merged_species_data)[which(names(merged_species_data) ==
            "external_gene_name")] <- paste(output_species, "symbol", sep = "_")
        merged_species_data <- merged_species_data[!duplicated(
            as.list(merged_species_data)
        )]
        if (input_id != "entrezgene_id") {
            entrez_id_col_name_input <- paste(input_species,
                "entrez_id",
                sep = "_"
            )
            merged_species_data <- merged_species_data %>%
                dplyr::select(-tidyselect::all_of(entrez_id_col_name_input))
        }
        if ("entrezgene_id" %in% output_ids == FALSE) {
            entrez_id_col_output <- paste(output_species,
                "entrez_id",
                sep = "_"
            )
            merged_species_data <- merged_species_data %>%
                dplyr::select(-tidyselect::all_of(entrez_id_col_output))
        }
        return(merged_species_data) # return the final table
    }
}


# homolog files

homolog <- function(entrez_data, species_number, ortholog_database) {
    if (ortholog_database == "HomoloGene") {
        myGenes <- as.character(entrez_data)
        species_one <- entrez_data
        homologene <- homologene::homologeneData2
        data <- annotationTools::getHOMOLOG(myGenes,
            species_number,
            homologene,
            noIDsymbol = NA,
            clusterCol = 1,
            speciesCol = 3,
            idCol = 4
        )
        data <- as.list(data)
        species_two <- as.character(data)
        homologs <- as.data.frame(species_two)
        homologs <- merge(data.frame(homologs, row.names = NULL),
            data.frame(species_one, row.names = NULL),
            by = 0, all = TRUE
        )[-1]
        manipulated_homologs <- data.frame(homologs)
        x <- nrow(manipulated_homologs)
        for (i in seq_len(x)) {
            ## print(i)
            char <- manipulated_homologs[i, 1]
            ## print(char)
            if ((char == "NA") == TRUE) {
                manipulated_homologs[i, 1] <- NA
            }
        }
        species_two_entrez_ID <- na.omit(manipulated_homologs)
        return(species_two_entrez_ID)
    }
    if (ortholog_database == "NCBIOrtho") {
        myGenes <- as.vector(entrez_data)
        species_one <- entrez_data
        NCBIOrtho <- readr::read_table(
            "https://ftp.ncbi.nih.gov/gene/DATA/gene_orthologs.gz",
            col_types = "ccccc",
            show_col_types = TRUE
        )
        NCBIOrtho <- as.data.frame(NCBIOrtho)
        data <- annotationTools::getHOMOLOG(myGenes,
            species_number,
            NCBIOrtho,
            tableType = "gene_orthologs"
        )
        data <- as.list(data)
        species_two <- as.character(data)
        homologs <- as.data.frame(species_two)
        homologs <- merge(data.frame(homologs, row.names = NULL),
            data.frame(species_one, row.names = NULL),
            by = 0, all = TRUE
        )[-1]
        manipulated_homologs <- data.frame(homologs)
        x <- nrow(manipulated_homologs)
        for (i in seq_len(x)) {
            ## print(i)
            char <- manipulated_homologs[i, 1]
            ## print(char)
            if ((char == "NA") == TRUE) {
                manipulated_homologs[i, 1] <- NA
            }
        }
        species_two_entrez_ID <- na.omit(manipulated_homologs)
        return(species_two_entrez_ID)
    }
}

# remove_version_number (only for inputs with Ensembl_id_version)

remove_version_numbers <- function(input_dataset, species) {
    if (species == "m_musculus") { # ENSMUSG00000032855.7
        input_dataset <- data.frame(input_dataset)
        colnames(input_dataset)[1] <- "ENSEMBL"
        x <- nrow(input_dataset)
        for (i in seq_len(x)) {
            char <- input_dataset[i, 1]
            char1 <- substr(char, start = 1, stop = 18)
            input_dataset[i, 1] <- char1
        }
        colnames(input_dataset)[which(names(input_dataset)
        == "ENSEMBL")] <- "input"
        return(input_dataset$input)
    }
    if (species == "h_sapiens") { # ENSG00000008710.20
        input_dataset <- data.frame(input_dataset)
        colnames(input_dataset)[1] <- "ENSEMBL"
        x <- nrow(input_dataset)
        for (i in seq_len(x)) {
            char <- input_dataset[i, 1]
            char1 <- substr(char, start = 1, stop = 15)
            input_dataset[i, 1] <- char1
        }
        colnames(input_dataset)[which(names(input_dataset)
        == "ENSEMBL")] <- "input"
        return(input_dataset$input)
    }

    if (species == "d_rerio") { # ENSDARG00000105344.2 (format)
        input_dataset <- data.frame(input_dataset)
        colnames(input_dataset)[1] <- "ENSEMBL"
        x <- nrow(input_dataset)
        for (i in seq_len(x)) {
            char <- input_dataset[i, 1]
            char1 <- substr(char, start = 1, stop = 18)
            input_dataset[i, 1] <- char1
        }
        colnames(input_dataset)[which(names(input_dataset)
        == "ENSEMBL")] <- "input"
        return(input_dataset$input)
    }

    if (species == "r_norvegicus") { # ENSRNOG00000010771.8 (format)
        input_dataset <- data.frame(input_dataset)
        colnames(input_dataset)[1] <- "ENSEMBL"
        x <- nrow(input_dataset)
        for (i in seq_len(x)) {
            char <- input_dataset[i, 1]
            char1 <- substr(char, start = 1, stop = 18)
            input_dataset[i, 1] <- char1
        }
        colnames(input_dataset)[which(names(input_dataset)
        == "ENSEMBL")] <- "input"
        return(input_dataset$input)
    }

    if (species == "c_elegans") {
        input_dataset <- data.frame(input_dataset)
        return(input_dataset$input)
    }
    if (species == "d_melanogaster") {
        input_dataset <- data.frame(input_dataset)
        return(input_dataset$input)
    } else {
        stop("Invalid species. Make sure it matches the proper format.")
    }
}

# CoSIA Utility Functions

# Find the Available/Common Tissues in CoSIA for a given combination of species

#' getTissues
#'
#' @param species name of a species or multiple species that you want to get
#' available tissue list for
#'
#' @return list of tissues that are common/available among the species or
#' multiple species inputted
#' @export
#'
#' @examples
#' tissue <- getTissues(c("d_rerio"))
getTissues <- function(species) {
    # Loading CoSIAdata
    CoSIAdata_load <- function(species) {
        eh <- ExperimentHub::ExperimentHub()
        merged_CoSIAdata <- data.frame(matrix(ncol = 9, nrow = 0))
        colnames(merged_CoSIAdata) <- c(
            "Anatomical_entity_name", "Ensembl_ID",
            "Sample_size", "VST", "Experiment_ID",
            "Anatomical_entity_ID", "Species", 
            "Scaled_Median_VST", "mad"
        )
        if (any(species == "m_musculus")) {
            mm_EH_File <- eh[["EH7859"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, mm_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(species == "r_norvegicus")) {
            rn_EH_File <- eh[["EH7860"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, rn_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(species == "d_rerio")) {
            dr_EH_File <- eh[["EH7861"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, dr_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(species == "h_sapiens")) {
            hs_EH_File <- eh[["EH7858"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, hs_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(species == "c_elegans")) {
            ce_EH_File <- eh[["EH7863"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, ce_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else if (any(species == "d_melanogaster")) {
            dm_EH_File <- eh[["EH7862"]][[1]]
            merged_CoSIAdata <- rbind(merged_CoSIAdata, dm_EH_File)
            merged_CoSIAdata <- as.data.frame(merged_CoSIAdata)
        } else {
            stop("Issue with species in CoSIAn Object. Make sure the species in the
          species argument are avalible organisms through CoSIA and are in the
          correct format.")
        }
        return(merged_CoSIAdata)
    }
    
    merged_CoSIAdata <- lapply(species, CoSIAdata_load)
    merged_CoSIAdata <- dplyr::bind_rows(merged_CoSIAdata)


    List_of_Tissues <- merged_CoSIAdata %>%
        dplyr::group_by(Anatomical_entity_name) %>%
        dplyr::reframe(
            Anatomical_entity_ID = unique(Anatomical_entity_ID),
            Species = unique(Species)
        )
    L <- List_of_Tissues %>% dplyr::group_by(Anatomical_entity_name)%>%
        dplyr::reframe(Frequency = table(Anatomical_entity_name))
    frequency_value <- length(species)
    common_tissue <- dplyr::filter(L, Frequency == frequency_value)
    common_tissue <- subset(common_tissue, select = -c(Frequency))
    colnames(common_tissue)[which(names(common_tissue) ==
        "Anatomical_entity_name")] <- "Common_Anatomical_Entity_Name"
    return(common_tissue)
}

#CoSIA Accessor Functions

#' viewCoSIAn Generics
#'
#' @param object CoSIAn object with all user accessible slots filled
#' @param slot_name name of output slots
#'
#' @return initializes a generic function for viewCoSIAn as preparation for
#' defining the viewCoSIAn Method 
#' @export
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c(
#'         "d_melanogaster"
#'     ),
#'     output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
#'     ortholog_database = "HomoloGene", map_tissues = "heart",
#'     map_species = c("d_melanogaster"), metric_type = "DS_Gene"
#' )
#' viewCoSIAn(Kidney_Genes, "converted_id")
#' 
setGeneric(
  "viewCoSIAn", 
  function(object, slot_name) standardGeneric("viewCoSIAn"))

#' viewCoSIAn
#'
#' @param object CoSIAn object with all user accessible slots filled
#' @param slot_name name of output slots
#' @return slots in CoSIAn object
#' @export
#'
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c("ENSG00000008710", "ENSG00000152217"),
#'     i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c(
#'         "d_melanogaster"
#'     ),
#'     output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
#'     ortholog_database = "HomoloGene", map_tissues = "heart",
#'     map_species = c("d_melanogaster"), metric_type = "DS_Gene"
#' )
#' viewCoSIAn(Kidney_Genes, "converted_id")
setMethod(
  "viewCoSIAn", 
  signature(object = "CoSIAn"), 
  function(object, slot_name) 
    ifelse(slot_name == "converted_id", object@converted_id, 
           ifelse(slot_name == "gex", object@gex, 
                  ifelse(slot_name == "metric", object@metric, 
                         stop("User provided slot does not exist"))))
  )

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)

## ----eval=FALSE---------------------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("CoSIA")

## ----setup, warning=FALSE, message=FALSE--------------------------------------
library(CoSIA)
load("../inst/extdata/proccessed/monogenic_kidney_genes.rda")


# downsampling data for figure
set.seed(42)
monogenic_kid_sample <- dplyr::sample_n(monogenic_kidney_genes, 20)


## ----getTissues_1, warning=FALSE, message=FALSE, eval=FALSE-------------------
# CoSIA::getTissues("d_rerio")

## ----getTissues_2, warning=FALSE, message=FALSE-------------------------------
CoSIA::getTissues(c("m_musculus", "r_norvegicus"))

## ----CoSIAnObj----------------------------------------------------------------
CoSIAn_Obj <- CoSIA::CoSIAn(
    gene_set = unique(monogenic_kid_sample$Gene),
    i_species = "h_sapiens",
    o_species = c(
        "h_sapiens",
        "r_norvegicus"
    ),
    input_id = "Symbol",
    output_ids = "Ensembl_id",
    map_species = c(
        "h_sapiens",
        "r_norvegicus"
    ),
    map_tissues = c(
        "adult mammalian kidney",
        "heart"
    ),
    mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene",
    metric_type = "CV_Species"
)

str(CoSIAn_Obj)

## ----use1,  message=FALSE, warning=FALSE--------------------------------------
CoSIAn_Obj_convert <- CoSIA::getConversion(CoSIAn_Obj)

head(CoSIA::viewCoSIAn(CoSIAn_Obj_convert, "converted_id"))

## ----use2_1,  message=FALSE, warning=FALSE, eval=FALSE------------------------
# CoSIAn_Obj_gex <- CoSIA::getGEx(CoSIAn_Obj_convert)
# 
# head(CoSIA::viewCoSIAn(CoSIAn_Obj_gex, "gex"), 5)

## ----plotSpeciesGEx, fig.small=TRUE, fig.cap = "Gene Expression of TACO1 in Kidney Across Species", message=FALSE, warning=FALSE, eval=FALSE----
# CoSIAn_Obj_gexplot <- CoSIA::plotSpeciesGEx(CoSIAn_Obj_gex, "adult mammalian kidney", "ENSG00000136463")
# 
# CoSIAn_Obj_gexplot

## ----plotCVGEx, dpi=200, fig.height=13, fig.width=6, fig.cap = "Gene Expression Variability Across Species in Kidney Tissue", fig.wide=TRUE, message=FALSE, warning=FALSE, eval=FALSE----
# 
# CoSIAn_Obj_CV <- CoSIA::getGExMetrics(CoSIAn_Obj_convert)
# 
# CoSIAn_Obj_CVplot <- CoSIA::plotCVGEx(CoSIAn_Obj_CV)
# 
# CoSIAn_Obj_CVplot

## ----use4, message=FALSE, warning=FALSE, eval=FALSE---------------------------
# CoSIAn_Obj_DS <- CoSIA::CoSIAn(
#     gene_set = unique(monogenic_kid_sample$Gene),
#     i_species = "h_sapiens",
#     o_species = c("h_sapiens", "r_norvegicus"),
#     input_id = "Symbol",
#     output_ids = "Ensembl_id",
#     map_species = c("h_sapiens", "r_norvegicus"),
#     map_tissues = c("adult mammalian kidney", "heart"),
#     mapping_tool = "annotationDBI",
#     ortholog_database = "HomoloGene",
#     metric_type = "DS_Tissue"
# )
# 
# CoSIAn_Obj_DS <- CoSIA::getConversion(CoSIAn_Obj_DS)
# 
# CoSIAn_Obj_DS <- CoSIA::getGExMetrics(CoSIAn_Obj_DS)
# 
# CoSIAn_Obj_DSplot <- CoSIA::plotDSGEx(CoSIAn_Obj_DS)
# 
# CoSIAn_Obj_DSplot

## -----------------------------------------------------------------------------
sessionInfo()

setClass("CoSIA", representation("VIRTUAL")) # virtual class
###############################################################################
#' @title CoSIAn Class S4 Object
#' @description This Class is used to specify the information needed to conduct
#' analysis using CoSIA's other methods. An object of this class will pass as an
#' argument to other methods in CoSIA
#' @rdname CoSIA-class
#' @slot gene_set character. A singular gene or a list of genes.
#' @slot i_species character. The species corresponding to gene_set.
#' @slot input_id character. The type of id corresponding to gene_set.
#' @slot o_species character. The singular or list of species that the gene set
#' is being converted to.
#' @slot output_ids character. The singular or list of id types that the gene
#' set is being converted to.
#' @slot mapping_tool character. The mapping tool, BiomaRt or annotationDBI,
#' being used to map the conversion between IDs.
#' @slot ortholog_database character. The ortholog database, HomoloGene or
#' NCBIOrtho, being used to map the conversion between species.
#' @slot converted_id data frame. Output of getConversion.
#' @slot map_tissues character. A list of tissues being investigated.
#' @slot map_species character. A list of species being investigated.
#' @slot gex data frame. Output of gene expression data.
#' @slot metric_type character. A list of possible metric the user wants to
#' calculate.
#' @slot metric data frame. Output of coefficient of variation of gene
#' expression data.
#' @exportClass CoSIAn
#' @import methods
#' @return CoSIAn object

setClass("CoSIAn", contains = "CoSIA", slots = c(
    gene_set = "character",
    i_species = "character",
    input_id = "character",
    o_species = "character",
    output_ids = "character",
    mapping_tool = "character",
    ortholog_database = "character",
    converted_id = "data.frame",
    map_tissues = "character",
    map_species = "character",
    gex = "data.frame",
    metric_type = "character",
    metric = "data.frame"
))
################################################################################
#' Constructor for the CoSIAn Object
#' @name CoSIAn-Constructor Constructor for the CoSIAn Class
#' @description The \code{CoSIAn} constructor creates a \code{CoSIAn} object
#' from character vector(s).
#' @rdname CoSIA-constructor
#' @param gene_set A singular gene or a list of genes.
#' @param i_species The species corresponding to gene_set.
#' @param input_id The type of id corresponding to gene_set.
#' @param o_species The singular or list of species that the gene set is being
#' converted to.
#' @param output_ids The singular or list of id types that the gene set is being
#'  converted to.
#' @param mapping_tool The mapping tool, BiomaRt or annotationDBI, being used to
#'  map the conversion between IDs.
#' @param ortholog_database The ortholog database, HomoloGene or NCBIOrtho,
#' being used to map the conversion between species.
#' @param map_tissues A list of tissues being investigated
#' @param map_species A list of species being investigated
#' @param metric_type A list of possible metric the user wants to calculate.
#' @return An S4 \code{CoSIAn} object with character vector(s) as slots.
#' @export
#' @examples
#' Kidney_Genes <- CoSIAn(
#'     gene_set = c(
#'         "ENSG00000008710", "ENSG00000118762",
#'         "ENSG00000152217"
#'     ), i_species = "h_sapiens", input_id = "Ensembl_id",
#'     o_species = c(
#'         "d_melanogaster", "m_musculus", "h_sapiens", "d_rerio",
#'         "c_elegans", "r_norvegicus"
#'     ), output_ids = c("Ensembl_id", "Symbol"),
#'     mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
#'     map_tissues = "heart", map_species = c("m_musculus"), 
#'     metric_type = "DS_Gene"
#' )
CoSIAn <- function(gene_set, i_species, input_id, o_species, output_ids,
                   mapping_tool = "annotationDBI",
                   ortholog_database = "HomoloGene",
                   map_tissues, map_species, metric_type) {
    if (length(gene_set) < 1) {
        stop("Please provide a valid gene set(gene_set)")
    }
    if (missing(i_species)) {
        stop("Please provide a valid input species(i_species)")
    }
    if (length(i_species) > 1) {
        stop("You can provide only one input species(i_species)")
    }
    if (missing(input_id)) {
        stop("Please provide a valid input gene identifier(input_id).
             Possible options are Ensembl_id, Entrez_id, Symbol.
             You can only provide one")
    }
    if (length(input_id) > 1) {
        stop("You can provide only one input id(input_id)")
    }
    if (length(i_species) != length(input_id)) {
        stop("Input species(i_species) and input gene identifier(input_id)
             must be the same length")
    }
    if (missing(o_species)) {
        stop("Please provide a valid output species(o_species)")
    }
    if (missing(output_ids)) {
        stop("Please provide a valid output gene identifier(output_ids).
             Possible options are Ensembl_id, Entrez_id, Symbol.
             You can provide multiple ids")
    }
    if (length(mapping_tool) > 1) {
        stop("You can provide only one database for mapping ids(mapping_tool)")
    }
    if (length(ortholog_database) > 1) {
        stop("You can provide only one database for
             mapping orthologs(ortholog_database)")
    }
    if (missing(map_tissues)) {
        stop("Please provide a valid tissue list(map_tissues)")
    }
    if (missing(map_species)) {
        stop("Please provide a valid output species(map_species)")
    }
    if (missing(metric_type)) {
        stop("Please provide a valid metric to be calculated(metric_type)")
    }
    methods::new("CoSIAn",
        gene_set = gene_set,
        i_species = i_species,
        input_id = input_id,
        o_species = o_species,
        output_ids = output_ids,
        mapping_tool = mapping_tool,
        ortholog_database = ortholog_database,
        map_tissues = map_tissues,
        map_species = map_species,
        metric_type = metric_type,
        converted_id = data.frame(0),
        gex = data.frame(0),
        metric = data.frame(0)
    )
}

## CoSIA Vignette Data
## Author: Amanda D. Clark
## Date Created: 01/10/23
## Purpose: Script is used to create data objects from the monogenic
## disease-associated kidney gene set from Natera.


## Natera's Monogenic Kidney Disease Panel (https://www.natera.com/resource-library/renasight/385-genes-associated-with-monogenic-disorders-linked-to-kidney-disease)
## can be downloaded using the link above. The panel is only available as a pdf
## Genes from the pdf were manually typed into the csv 
## file available in "/inst/extdata/raw"

# Load raw data
monogenic_kidney_genes <-
    readr::read_csv(
        file = "inst/extdata/raw/385_NateraKidney.csv",
        col_names = TRUE
    )

# Output RDS
saveRDS(
    object = monogenic_kidney_genes,
    file = "inst/extdata/proccessed/monogenic_kidney_genes.rds"
)

# Output RDA
save(monogenic_kidney_genes,
    file = "inst/extdata/proccessed/monogenic_kidney_genes.rda"
)

#!/usr/bin/env bash
set -euo pipefail

PROJECT_PATH="$(pwd)"
CONTAINER_PATH="$PROJECT_PATH/bin/container"
SIF="${CONTAINER_PATH}/bioc_cosia_1.10.0.sif"
SIF_URI="${COSIA_SIF_URI:-docker://lizzyr/bioc_cosia:1.10.0}"

ensure_sif() {
    mkdir -p "$CONTAINER_PATH"
    if [[ -f "$SIF" ]]; then
        return
    fi
    echo "SIF not found: $SIF"
    echo "Pulling from $SIF_URI ..."
    singularity pull "$SIF" "$SIF_URI"
}

CACHE_BASE="/data/user/$USER/bioconductor/bioc-cache"
TMP_BASE="/data/user/$USER/bioconductor/bioc-tmp"

ensure_sif

mkdir -p \
  "$CACHE_BASE/home" \
  "$CACHE_BASE/annotationhub" \
  "$CACHE_BASE/experimenthub" \
  "$CACHE_BASE/biocfilecache" \
  "$CACHE_BASE/xdg" \
  "$TMP_BASE"

singularity exec --cleanenv \
  --containall \
  --home "${CACHE_BASE}/home:/home/${USER}" \
  -B "${PROJECT_PATH}" \
  -B "${CACHE_BASE}:${CACHE_BASE}" \
  -B "${TMP_BASE}:/tmp" \
  -B "${TMP_BASE}:/var/tmp" \
  --env TMPDIR="/tmp" \
  --env TMP="/tmp" \
  --env TEMP="/tmp" \
  --env XDG_CACHE_HOME="${CACHE_BASE}/xdg" \
  --env ANNOTATION_HUB_CACHE="${CACHE_BASE}/annotationhub" \
  --env EXPERIMENT_HUB_CACHE="${CACHE_BASE}/experimenthub" \
  --env BFC_CACHE="${CACHE_BASE}/biocfilecache" \
  --pwd "${PROJECT_PATH}" \
  "$SIF" \
  Rscript -e "devtools::test()"

---
title: "CoSIA, an R package for Cross Species Investigation and Analysis"
output: 
  BiocStyle::html_document:
    toc: true
    toc_float: true
    
vignette: >
  %\VignetteIndexEntry{CoSIA_Intro}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
author: 
- name: Anisha Haldar
- name: Vishal H. Oza
- name: Nathaniel DeVoss
- name: Amanda D. Clark
- name: Brittany N. Lasseigne
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

------------------------------------------------------------------------

# Summary

**C**r**o**ss **S**pecies **I**nvestigation and **A**nalysis (`CoSIA`) is a package that provides researchers with an alternative methodology for comparing across species and tissues using normal wild-type RNA-Seq Gene Expression data from Bgee. Using RNA-Seq Gene Expression data, CoSIA provides multiple visualization tools to explore the transcriptome diversity and variation across genes, tissues, and species. CoSIA uses the Coefficient of Variation and Shannon Entropy and Specificity to calculate transcriptome diversity and variation. CoSIA also provides additional conversion tools and utilities to provide a streamlined methodology for cross-species comparison.

<img src="../inst/images/CoSIA_Workflow.png" alt="Figure 1. CoSIA_Workflow" width="703"/>

CoSIA is split into 3 methods that provide various resources in order for researchers to conduct cross species analysis using gene expression metrics.

-   Method 1 uses `getConversion` to convert inputs between different gene identifiers in the same species as well as orthologs in different species. The other modules access tissue- and/or species-specific gene expression.

-   Method 2 uses `getGEx` to obtain raw read counts that undergo Variance Stabilizing Transformation via DESeq2 methodology. Gene expression values are visualized for a single gene *across multiple tissues in single model organism* or *across multiple species in a single tissue* using the plotting methods, `plotTissueGEx` & `plotSpeciesGEx`, respectively.

-   Method 3 uses `getGExMetrics` to calculate median-based Coefficient of Variation (variability) and Shannon Entropy (diversity & specificity). There are two accompanying plotting methods, `plotCVGEx` & `plotDSGEx` that are used to visualize the variation and diversity & specificity (DS) of gene expression across genes, tissues, and species.

------------------------------------------------------------------------

## Installation

In R:

```{r, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("CoSIA")
```

## Generating a CoSIAn object

### Load CoSIA

```{r setup, warning=FALSE, message=FALSE}
library(CoSIA)
load("../inst/extdata/proccessed/monogenic_kidney_genes.rda")


# downsampling data for figure
set.seed(42)
monogenic_kid_sample <- dplyr::sample_n(monogenic_kidney_genes, 20)

```

### Arguments and options table

+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| Slot Name                         | Possible Value Options                                                             | Default       |
+:=================================:+:==================================================================================:+:=============:+
| gene_set                          | "character", c(characters), data.frame\$column                                     | N/A           |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| i_species; o_species; map_species | "h_sapiens", "m_musculus", "r_noregicus", "d_rerio", "d_melangoaster", "c_elegans" | N/A           |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| mapping_tool                      | "annotationDBI", "biomaRt"                                                         | annotationDBI |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| input_id; output_ids              | "Ensembl_id", "Entrez_id", "Symbol"                                                | N/A           |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| ortholog_database                 | "NCBIOrtho", "HomoloGene"                                                          | HomoloGene    |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| map_tissue                        | c("tissue"), "tissue"; see `getTissues`                                            | N/A           |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+
| metric_type                       | "CV_Tissue", "CV_Species", "DS_Gene", "DS_Gene_all", "DS_Tissue", "DS_Tissue_all"  | N/A           |
+-----------------------------------+------------------------------------------------------------------------------------+---------------+

: (#tab:Table1.) CoSIA Arguments and Options.

### Find possible tissues with `getTissues`

The function `getTissues` retrieves tissues available for a single species:

```{r getTissues_1, warning=FALSE, message=FALSE, eval=FALSE}
CoSIA::getTissues("d_rerio")
```

...or tissues shared across a list of species:

```{r getTissues_2, warning=FALSE, message=FALSE}
CoSIA::getTissues(c("m_musculus", "r_norvegicus"))
```

*NOTE*: To compare across all shared tissues for your selected species, you can assign the `getTissues` output to an object as input for `map_tissues` when initializing a CoSIAn object.

### Initializing a CoSIAn object

```{r CoSIAnObj}
CoSIAn_Obj <- CoSIA::CoSIAn(
    gene_set = unique(monogenic_kid_sample$Gene),
    i_species = "h_sapiens",
    o_species = c(
        "h_sapiens",
        "r_norvegicus"
    ),
    input_id = "Symbol",
    output_ids = "Ensembl_id",
    map_species = c(
        "h_sapiens",
        "r_norvegicus"
    ),
    map_tissues = c(
        "adult mammalian kidney",
        "heart"
    ),
    mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene",
    metric_type = "CV_Species"
)

str(CoSIAn_Obj)
```

*NOTE*: Any species you plan to compare must be specified in `map_species` AND `o_species`.

*NOTE*: The `getGEx` function requires that "Ensembl_id" is included as an `output_id`. Here, we convert gene symbols into Ensembl IDs.

## Use Cases with Monogenic Kidney Disease-Associated Genes

The following use cases provide running examples of CoSIA applications with [Natera's Monogenic Kidney Disease Panel](https://www.natera.com/resource-library/renasight/385-genes-associated-with-monogenic-disorders-linked-to-kidney-disease). We will perform id conversion, obtain and visualize gene expression data, and calculate and visualize CV and DS of gene expression across three species (human, mouse, & rat) and two tissues (kidney & heart).

### Use Case #1: Converting Gene Symbols to Ensembl IDs (`getConversion`)

CoSIA can convert input ids to any of the types listed in Table \@ref(tab:Table1.).

```{r use1,  message=FALSE, warning=FALSE}
CoSIAn_Obj_convert <- CoSIA::getConversion(CoSIAn_Obj)

head(CoSIA::viewCoSIAn(CoSIAn_Obj_convert, "converted_id"))
```

------------------------------------------------------------------------

### Use Case #2: Obtaining and visualizing curated non-diseased kidney and heart gene expression data for human, mouse, rat from Bgee

Now we will use the converted IDs with `getGEx` to obtain heart and kidney gene expression data for human, mouse and rat curated from Bgee.

```{r use2_1,  message=FALSE, warning=FALSE, eval=FALSE}
CoSIAn_Obj_gex <- CoSIA::getGEx(CoSIAn_Obj_convert)

head(CoSIA::viewCoSIAn(CoSIAn_Obj_gex, "gex"), 5)
```

These data can be visualized with `plotSpeciesGEx` to plot expression of a single gene in a single tissue across species or `plotTissueGEx` to plot expression of a single gene in a single species across tissues.

Here we are plotting gene expression for the [TACO1](https://www.proteinatlas.org/ENSG00000136463-TACO1) gene in kidney tissue for human, mouse, and rat.

```{r plotSpeciesGEx, fig.small=TRUE, fig.cap = "Gene Expression of TACO1 in Kidney Across Species", message=FALSE, warning=FALSE, eval=FALSE}
CoSIAn_Obj_gexplot <- CoSIA::plotSpeciesGEx(CoSIAn_Obj_gex, "adult mammalian kidney", "ENSG00000136463")

CoSIAn_Obj_gexplot
```
<img src="../inst/images/CoSIA_vignette_gex_TACO1.png" alt="Figure 3. Gene Expression of TACO1 in Kidney Across Selected Species" width="703"/>

CoSIA produces an interactive plot of expression values for TACO1 in kidney for human mouse and rat. Hovering over the plot displays sample-specific VST read count values. For file size compliance, we have included a static plot for this output. 
*NOTE:* Expression values are not meant to be compared across species in this plot. The next two use cases demonstrate appropriate methods for comparing gene expression patterns across species.

------------------------------------------------------------------------

### Use Case #3: Gene expression variability across species for kidney tissue by calculating and visualizing median-based Coefficient of Variation (CV)

Calculating and visualizing median-based coefficient of variation allows for a relative comparison of gene expression variability between species. In CoSIA, CV is calculated as the standard deviation over the median using VST read count values. In the section \@ref(initializing-a-cosian-object), we set `metric_type= "CV_Species"` to calculate CV for the monogenic kidney gene set across human and rat.

```{r plotCVGEx, dpi=200, fig.height=13, fig.width=6, fig.cap = "Gene Expression Variability Across Species in Kidney Tissue", fig.wide=TRUE, message=FALSE, warning=FALSE, eval=FALSE}

CoSIAn_Obj_CV <- CoSIA::getGExMetrics(CoSIAn_Obj_convert)

CoSIAn_Obj_CVplot <- CoSIA::plotCVGEx(CoSIAn_Obj_CV)

CoSIAn_Obj_CVplot
```
<img src="../inst/images/CoSIA_CV_example.png" alt="Figure 4. Gene Expression Variability Across Species in Kidney Tissue" width="703"/>

Here we see relatively low variability in gene expression of most genes in rat and human, with the exception of relatively high levels of variation in `metric_type= "CV_Tissue"` displays the variability of gene expression for the monogenic gene set across selected, shared tissues.

------------------------------------------------------------------------

### Use Case #4: Gene expression diversity and specificity across tissues and species for monogenic kidney-disease associated genes

Diversity and specificity metrics are also suitable for comparing gene expression patterns across species. In CoSIA, diversity and specificity (based on Shannon's entropy) are calculated using min-max scaled median VST values generated each gene in a tissue- and species-specific manner. Values are used to calculate diversity and specificity as in [Martínez & Reyes-Valdés, 2008](https://www.pnas.org/doi/10.1073/pnas.0803479105).

In the final use case, we are calculating and visualizing diversity and specificity for kidney and heart tissue across the monogenic kidney gene set by setting `metric_type= "DS_Tissue"`. There are additional metric_types for the CoSIAn objects, view \@ref(tab:Table2.) This example is not run, but the code and the resulting static output is included.

```{r use4, message=FALSE, warning=FALSE, eval=FALSE}
CoSIAn_Obj_DS <- CoSIA::CoSIAn(
    gene_set = unique(monogenic_kid_sample$Gene),
    i_species = "h_sapiens",
    o_species = c("h_sapiens", "r_norvegicus"),
    input_id = "Symbol",
    output_ids = "Ensembl_id",
    map_species = c("h_sapiens", "r_norvegicus"),
    map_tissues = c("adult mammalian kidney", "heart"),
    mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene",
    metric_type = "DS_Tissue"
)

CoSIAn_Obj_DS <- CoSIA::getConversion(CoSIAn_Obj_DS)

CoSIAn_Obj_DS <- CoSIA::getGExMetrics(CoSIAn_Obj_DS)

CoSIAn_Obj_DSplot <- CoSIA::plotDSGEx(CoSIAn_Obj_DS)

CoSIAn_Obj_DSplot
```
<img src="../inst/images/CoSIA_DS_Gene_example.png" alt="Figure 5. Diversity vs Specificity of Genes in Geneset Across Anatomical Entity Names" width="703"/>

There is low specificity in kidney tissue, indicating there are more genes from the set that are expressed in kidney. We see higher specificity in heart tissue, indicating that there are fewer genes from the set that are expressed in heart.

+---------------+---------------------------------------------------------------------------------------------------------------+
| Metric Type   | Function                                                                                                      |
+===============+===============================================================================================================+
| DS_Gene       | calculates diversity and specificity across genes in `gene_set` in the tissues listed in `map_tissue`         |
+---------------+---------------------------------------------------------------------------------------------------------------+
| DS_Gene_all   | calculates diversity and specificity across genes in `gene_set` in the all the available tissues in a species |
+---------------+---------------------------------------------------------------------------------------------------------------+
| DS_Tissue     | calculates diversity and specificity across tissues listed in `map_tissue` in the genes in `gene_set`         |
+---------------+---------------------------------------------------------------------------------------------------------------+
| DS_Tissue_all | calculates diversity and specificity across tissues listed in `map_tissue` in the all the genes in a species  |
+---------------+---------------------------------------------------------------------------------------------------------------+

: (#tab:Table2.) CoSIA Metric Type options.


Session info

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-getGExMetrics-method.R
\name{getGExMetrics,CoSIAn-method}
\alias{getGExMetrics,CoSIAn-method}
\title{getGExMetrics Method}
\usage{
\S4method{getGExMetrics}{CoSIAn}(object)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled with
converted_id slot filled}
}
\value{
CoSIAn Object with metric slot filled
}
\description{
getGExMetrics Method
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
        "h_sapiens", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = "heart", map_species = c("r_norvegicus"),
    metric_type = "DS_Gene"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
}
\references{
Kohl M (2022). MKdescr: Descriptive Statistics. R package version 
0.8, https://github.com/stamats/MKdescr.

Zhang JD, Hatje K, Sturm G, Broger C, Ebeling M, Burtin M, Terzi 
F, Pomposiello SI, Badi L (2017). “Detect tissue heterogeneity in gene 
expression data with BioQC.” BMC Genomics, 18(1), 277. 
http://accio.github.io/BioQC/.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-plots-method.R
\name{plotCVGEx,CoSIAn-method}
\alias{plotCVGEx,CoSIAn-method}
\title{plotCVGEx Method}
\usage{
\S4method{plotCVGEx}{CoSIAn}(object)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled in as well
as the converted_id and metric slot filled}
}
\value{
plot object
}
\description{
plotCVGEx Method
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
        "h_sapiens", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = c("adult mammalian kidney","heart"), 
    map_species = c("h_sapiens", "r_norvegicus"),
    metric_type = "CV_Tissue"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
plot <- plotCVGEx(Kidney_gene_metric)
}
\references{
Dot plot in R with the dotchart function [with examples]. 
R CODER. (2020, November 20). Retrieved from https://r-coder.com/dot-plot-r/
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-utility-method.R
\name{getTissues}
\alias{getTissues}
\title{getTissues}
\usage{
getTissues(species)
}
\arguments{
\item{species}{name of a species or multiple species that you want to get
available tissue list for}
}
\value{
list of tissues that are common/available among the species or
multiple species inputted
}
\description{
getTissues
}
\examples{
tissue <- getTissues(c("m_musculus"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-plots-method.R
\name{plotSpeciesGEx}
\alias{plotSpeciesGEx}
\title{plotSpeciesGEx Generic}
\usage{
plotSpeciesGEx(object, single_tissue, single_gene)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled in as well
as the converted_id and gex slot filled}

\item{single_tissue}{one tissue that the user wants to investigate across the
mapped species}

\item{single_gene}{one ensembl id that the user wants to investigate across
the mapped species}
}
\value{
initializes a generic function for plotSpeciesGEx as preparation for
defining the plotSpeciesGEx Method
}
\description{
plotSpeciesGEx Generic
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
        "d_melanogaster", "m_musculus",
        "h_sapiens", "d_rerio", "c_elegans", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = "heart", map_species = c("m_musculus"),
    metric_type = "DS_Gene"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
plotSpeciesGEx(Kidney_gene_gex, "liver", "ENSG00000008710")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-plots-method.R
\name{plotDSGEx,CoSIAn-method}
\alias{plotDSGEx,CoSIAn-method}
\title{plotDSGEx Method}
\usage{
\S4method{plotDSGEx}{CoSIAn}(object)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled in as well
as the converted_id and metric slot filled}
}
\value{
plot object
}
\description{
plotDSGEx Method
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id", o_species = c(
        "d_melanogaster", "m_musculus",
        "h_sapiens", "d_rerio", "c_elegans", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = "heart", map_species = c("m_musculus"),
    metric_type = "DS_Gene"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
Kidney_gene_metric <- getGExMetrics(Kidney_gene_conversion)
plotDSGEx(Kidney_gene_metric)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-utility-method.R
\name{viewCoSIAn}
\alias{viewCoSIAn}
\title{viewCoSIAn Generics}
\usage{
viewCoSIAn(object, slot_name)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled}

\item{slot_name}{name of output slots}
}
\value{
initializes a generic function for viewCoSIAn as preparation for
defining the viewCoSIAn Method
}
\description{
viewCoSIAn Generics
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id",
    o_species = c(
        "d_melanogaster"
    ),
    output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene", map_tissues = "heart",
    map_species = c("d_melanogaster"), metric_type = "DS_Gene"
)
viewCoSIAn(Kidney_Genes, "converted_id")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-class.R
\name{CoSIAn-Constructor Constructor for the CoSIAn Class}
\alias{CoSIAn-Constructor Constructor for the CoSIAn Class}
\alias{CoSIAn}
\title{Constructor for the CoSIAn Object}
\usage{
CoSIAn(
  gene_set,
  i_species,
  input_id,
  o_species,
  output_ids,
  mapping_tool = "annotationDBI",
  ortholog_database = "HomoloGene",
  map_tissues,
  map_species,
  metric_type
)
}
\arguments{
\item{gene_set}{A singular gene or a list of genes.}

\item{i_species}{The species corresponding to gene_set.}

\item{input_id}{The type of id corresponding to gene_set.}

\item{o_species}{The singular or list of species that the gene set is being
converted to.}

\item{output_ids}{The singular or list of id types that the gene set is being
converted to.}

\item{mapping_tool}{The mapping tool, BiomaRt or annotationDBI, being used to
map the conversion between IDs.}

\item{ortholog_database}{The ortholog database, HomoloGene or NCBIOrtho,
being used to map the conversion between species.}

\item{map_tissues}{A list of tissues being investigated}

\item{map_species}{A list of species being investigated}

\item{metric_type}{A list of possible metric the user wants to calculate.}
}
\value{
An S4 \code{CoSIAn} object with character vector(s) as slots.
}
\description{
The \code{CoSIAn} constructor creates a \code{CoSIAn} object
from character vector(s).
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c(
        "ENSG00000008710", "ENSG00000118762",
        "ENSG00000152217"
    ), i_species = "h_sapiens", input_id = "Ensembl_id",
    o_species = c(
        "d_melanogaster", "m_musculus", "h_sapiens", "d_rerio",
        "c_elegans", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = "heart", map_species = c("m_musculus"), 
    metric_type = "DS_Gene"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-class.R
\docType{class}
\name{CoSIAn-class}
\alias{CoSIAn-class}
\title{CoSIAn Class S4 Object}
\value{
CoSIAn object
}
\description{
This Class is used to specify the information needed to conduct
analysis using CoSIA's other methods. An object of this class will pass as an
argument to other methods in CoSIA
}
\section{Slots}{

\describe{
\item{\code{gene_set}}{character. A singular gene or a list of genes.}

\item{\code{i_species}}{character. The species corresponding to gene_set.}

\item{\code{input_id}}{character. The type of id corresponding to gene_set.}

\item{\code{o_species}}{character. The singular or list of species that the gene set
is being converted to.}

\item{\code{output_ids}}{character. The singular or list of id types that the gene
set is being converted to.}

\item{\code{mapping_tool}}{character. The mapping tool, BiomaRt or annotationDBI,
being used to map the conversion between IDs.}

\item{\code{ortholog_database}}{character. The ortholog database, HomoloGene or
NCBIOrtho, being used to map the conversion between species.}

\item{\code{converted_id}}{data frame. Output of getConversion.}

\item{\code{map_tissues}}{character. A list of tissues being investigated.}

\item{\code{map_species}}{character. A list of species being investigated.}

\item{\code{gex}}{data frame. Output of gene expression data.}

\item{\code{metric_type}}{character. A list of possible metric the user wants to
calculate.}

\item{\code{metric}}{data frame. Output of coefficient of variation of gene
expression data.}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-getConversion-method.R
\name{getConversion}
\alias{getConversion}
\title{getConversion Generic}
\usage{
getConversion(object)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled}
}
\value{
initializes a generic function for getConversion as preparation for
defining the getConversion Method
}
\description{
getConversion Generic
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id",
    o_species = c(
        "d_melanogaster", "m_musculus", "h_sapiens", "d_rerio",
        "c_elegans", "r_norvegicus"
    ),
    output_ids = c("Ensembl_id", "Symbol"), mapping_tool = "annotationDBI",
    ortholog_database = "HomoloGene", map_tissues = "heart",
    map_species = c("m_musculus"), metric_type = "DS_Gene"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CoSIA-getGEx-method.R
\name{getGEx,CoSIAn-method}
\alias{getGEx,CoSIAn-method}
\title{getGEx Method}
\usage{
\S4method{getGEx}{CoSIAn}(object)
}
\arguments{
\item{object}{CoSIAn object with all user accessible slots filled with
converted_id slot filled}
}
\value{
CoSIAn Object with gex slot filled
}
\description{
getGEx Method
}
\examples{
Kidney_Genes <- CoSIAn(
    gene_set = c("ENSG00000008710", "ENSG00000118762", "ENSG00000152217"),
    i_species = "h_sapiens", input_id = "Ensembl_id",
    o_species = c(
        "h_sapiens", "r_norvegicus"
    ), output_ids = c("Ensembl_id", "Symbol"),
    mapping_tool = "annotationDBI", ortholog_database = "HomoloGene",
    map_tissues = "heart", map_species = c("r_norvegicus"),
    metric_type = "DS_Gene"
)
Kidney_gene_conversion <- CoSIA::getConversion(Kidney_Genes)
Kidney_gene_gex <- getGEx(Kidney_gene_conversion)
}
